#!/bin/csh -f

#
# File produced by the obuild tool version 1.10.0
# for the package CoinQt with version v1r130p8.
#

#////////////////////////////////////////////////
# Usage :
#   csh> source setup.csh
#////////////////////////////////////////////////

#set verbose  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

set obuild_CoinQt_path="@@absolute_dir@@"


if ( "${obuild_CoinQt_path}" == '@@absolute_dir@@' ) then
  echo '  The package CoinQt had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    CoinQt/<vers>/obuild/setup.csh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  exit
endif

if ( $?OBUILD_DIR_BIN ) then
  if (  "${OBUILD_DIR_BIN}" == "" ) then
    set obuild_dir_bin=bin_obuild
  else
    set obuild_dir_bin=${OBUILD_DIR_BIN}
  endif
else
  set obuild_dir_bin=bin_obuild
endif

if ( "${obuild_dir_bin}" == "" ) then
  echo "obuild_dir_bin variable not defined."
  exit
endif

/bin/mkdir -p "${obuild_CoinQt_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" ) then
  if ( ! -e "${obuild_CoinQt_path}/obuild/cpp/obuild_platform.cpp" ) then
    echo "Program source obuild_platform.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_platform_compiler=${OBUILD_CXX}
      else
        set obuild_platform_compiler=c++
      endif
    else
      set obuild_platform_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_platform_compiler=c++
  endif
  ${obuild_platform_compiler} -o "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" "${obuild_CoinQt_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if ( ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" ) then
    echo "Program obuild_platform not found."
    exit
  endif
endif
set obuild_platform_exe="${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform"
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/usr/bin/moc"
endif
unset obuild_platform_result
if ( "`printenv OBUILD_SITE`" != "afs_lcg_osx105_ia32_gcc401" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_fmk="/Library/Frameworks"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "afs_lcg_osx105_ia32_gcc401" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/afs/cern.ch/sw/lcg/external/qt/4.4.2/osx105_ia32_gcc401"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "afs_lcg_osx105_ia32_gcc401" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="${Qt_home}/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "afs_lcg_osx105_ia32_gcc401" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="${Qt_home}/include"
endif
unset obuild_platform_result
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/usr/include/qt4"
endif
unset obuild_platform_result
if ( -d "/usr/include/QtCore" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/usr/include"
endif
unset obuild_platform_result
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/usr/lib"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/usr/bin/moc"
endif
unset obuild_platform_result
if ( -e "/usr/bin/moc-qt4" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/usr/bin/moc-qt4"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "pc-panoramix" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/usr/include/qt-4.3"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "pc-panoramix" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/usr/lib/qt-4.3"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "pc-panoramix" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/usr/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc34-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/include"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc34-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/lib"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc34-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc43-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/include"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc43-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/lib"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_x86_64-slc5-gcc43-opt" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/include"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/lib"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc43" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/include"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc43" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/lib"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_amd64_gcc43" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/bin/moc"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/include"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/lib"
endif
unset obuild_platform_result
endif
if ( "`printenv OBUILD_SITE`" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/bin/moc"
endif
unset obuild_platform_result
endif
/bin/mkdir -p "${obuild_CoinQt_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" ) then
  if ( ! -e "${obuild_CoinQt_path}/obuild/cpp/obuild_find.cpp" ) then
    echo "Program source obuild_find.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_find_compiler=${OBUILD_CXX}
      else
        set obuild_find_compiler=c++
      endif
    else
      set obuild_find_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_find_compiler=c++
  endif
  ${obuild_find_compiler} -o "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" "${obuild_CoinQt_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if ( ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" ) then
    echo "Program obuild_find not found."
    exit
  endif
endif
set obuild_find_exe="${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find"
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinGL_path=`"${obuild_find_exe}" CoinGL ''`

# Execute setup of used packages :
source "${obuild_CoinGL_path}/obuild/setup.csh"

# Set environment variables of this package :

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_CoinQt_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_CoinQt_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_CoinQt_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${Qt_lib_dir}"
  else
    setenv DYLD_LIBRARY_PATH "${Qt_lib_dir}"
  endif
endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${Qt_lib_dir}"
else
  setenv PATH "${Qt_lib_dir}"
endif

endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${Qt_lib_dir}"
  else
    setenv LD_LIBRARY_PATH "${Qt_lib_dir}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_CoinQt_path}/${obuild_dir_bin}"
endif

unset obuild_CoinQt_path

#FIXME unset obuild_dir_bin
