#!/bin/sh -f

#
# File produced by the obuild tool version 1.10.0
# for the package CoinQt with version v1r130p8.
#

#////////////////////////////////////////////////
# Usage :
#   sh> . setup.sh
#////////////////////////////////////////////////

#set -x  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

obuild_CoinQt_path="@@absolute_dir@@"

if [ "${obuild_CoinQt_path}" = '@@absolute_dir@@' ] ; then
  echo '  The package CoinQt had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    CoinQt/<vers>/obuild/setup.sh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  return
fi

if [  "${OBUILD_DIR_BIN}" = "" ] ; then
  obuild_dir_bin=bin_obuild
else
  obuild_dir_bin=${OBUILD_DIR_BIN}
fi

if [ "${obuild_dir_bin}" = "" ] ; then
  echo "obuild_dir_bin variable not defined."
  return
fi

/bin/mkdir -p "${obuild_CoinQt_path}/${obuild_dir_bin}"
if [ ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" ] ; then
  if [ ! -e "${obuild_CoinQt_path}/obuild/cpp/obuild_platform.cpp" ] ; then
    echo "Program source obuild_platform.cpp not found."
    return
  fi
  if [ "${obuild_cxx_command}" = "" ] ; then 
    if [  "${OBUILD_CXX}" != "" ] ; then
      obuild_platform_compiler=${OBUILD_CXX}
    else
      obuild_platform_compiler=c++ 
    fi
  else
    obuild_platform_compiler=${obuild_cxx_command} 
  fi
  ${obuild_platform_compiler} -o "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" "${obuild_CoinQt_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if [ ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform" ] ; then
    echo "Program obuild_platform not found."
    return
  fi
fi
obuild_platform_exe="${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_platform"
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/usr/bin/moc"
fi
unset obuild_platform_result
if [ "${OBUILD_SITE}" != "afs_lcg_osx105_ia32_gcc401" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_fmk="/Library/Frameworks"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "afs_lcg_osx105_ia32_gcc401" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/afs/cern.ch/sw/lcg/external/qt/4.4.2/osx105_ia32_gcc401"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "afs_lcg_osx105_ia32_gcc401" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="${Qt_home}/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "afs_lcg_osx105_ia32_gcc401" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="${Qt_home}/include"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/usr/include/qt4"
fi
unset obuild_platform_result
if [ -d "/usr/include/QtCore" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/usr/include"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/usr/lib"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/usr/bin/moc"
fi
unset obuild_platform_result
if [ -e "/usr/bin/moc-qt4" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/usr/bin/moc-qt4"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "pc-panoramix" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/usr/include/qt-4.3"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "pc-panoramix" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/usr/lib/qt-4.3"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "pc-panoramix" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/usr/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc34-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/include"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc34-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/lib"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc34-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc34-opt/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc43-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/include"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc43-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/lib"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_x86_64-slc5-gcc43-opt" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/x86_64-slc5-gcc43-opt/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/include"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/lib"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc34/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc43" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/include"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc43" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/lib"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc43" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_amd64_gcc43/bin/moc"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_inc_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/include"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_lib_dir="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/lib"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_moc="/afs/cern.ch/sw/lcg/external/qt/4.4.2/slc4_ia32_gcc34/bin/moc"
fi
unset obuild_platform_result
fi
/bin/mkdir -p "${obuild_CoinQt_path}/${obuild_dir_bin}"
if [ ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" ] ; then
  if [ ! -e "${obuild_CoinQt_path}/obuild/cpp/obuild_find.cpp" ] ; then
    echo "Program source obuild_find.cpp not found."
    return
  fi
  if [ "${obuild_cxx_command}" = "" ] ; then
    if [  "${OBUILD_CXX}" != "" ] ; then
      obuild_find_compiler=${OBUILD_CXX}
    else
      obuild_find_compiler=c++
    fi
  else
    obuild_find_compiler=${obuild_cxx_command}
  fi
  ${obuild_find_compiler} -o "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" "${obuild_CoinQt_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if [ ! -e "${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find" ] ; then
    echo "Program obuild_find not found."
    return
  fi
fi
obuild_find_exe="${obuild_CoinQt_path}/${obuild_dir_bin}/obuild_find"
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinGL_path=`"${obuild_find_exe}" CoinGL ''`
if [ "${obuild_CoinGL_path}" = "" ] ; then
  echo "Can't find CoinGL package."
  return
fi

# Execute setup of used packages :
if [ ! -e "${obuild_CoinGL_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package CoinGL."
  return
fi
. "${obuild_CoinGL_path}/obuild/setup.sh"

# Set environment variables of this package :

if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
  if [  "${DYLD_LIBRARY_PATH}" = "" ] ; then
    DYLD_LIBRARY_PATH="${obuild_CoinQt_path}/${obuild_dir_bin}"
    export DYLD_LIBRARY_PATH
  else
    DYLD_LIBRARY_PATH="${DYLD_LIBRARY_PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
    export DYLD_LIBRARY_PATH
  fi
else
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if [ ${obuild_platform_result} = yes ] ; then
if [  "${PATH}" = "" ] ; then
  PATH="${obuild_CoinQt_path}/${obuild_dir_bin}"
  export PATH
else
  PATH="${PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
  export PATH
fi
else
  if [  "${LD_LIBRARY_PATH}" = "" ] ; then
    LD_LIBRARY_PATH="${obuild_CoinQt_path}/${obuild_dir_bin}"
    export LD_LIBRARY_PATH
  else
    LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
    export LD_LIBRARY_PATH
  fi
fi
unset obuild_platform_result
fi
unset obuild_platform_result

if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
  if [  "${DYLD_LIBRARY_PATH}" = "" ] ; then
    DYLD_LIBRARY_PATH="${Qt_lib_dir}"
    export DYLD_LIBRARY_PATH
  else
    DYLD_LIBRARY_PATH="${DYLD_LIBRARY_PATH}:${Qt_lib_dir}"
    export DYLD_LIBRARY_PATH
  fi
fi
unset obuild_platform_result
else
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if [ ${obuild_platform_result} = yes ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
if [  "${PATH}" = "" ] ; then
  PATH="${Qt_lib_dir}"
  export PATH
else
  PATH="${PATH}:${Qt_lib_dir}"
  export PATH
fi
fi
unset obuild_platform_result
else
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
  if [  "${LD_LIBRARY_PATH}" = "" ] ; then
    LD_LIBRARY_PATH="${Qt_lib_dir}"
    export LD_LIBRARY_PATH
  else
    LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:${Qt_lib_dir}"
    export LD_LIBRARY_PATH
  fi
fi
unset obuild_platform_result
fi
unset obuild_platform_result
fi
unset obuild_platform_result

if [  "${PATH}" = "" ] ; then
  PATH="${obuild_CoinQt_path}/${obuild_dir_bin}"
  export PATH
else
  PATH="${PATH}:${obuild_CoinQt_path}/${obuild_dir_bin}"
  export PATH
fi
unset obuild_CoinQt_path

#FIXME unset obuild_dir_bin
