/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 2000-2001 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// @configure_input@
// 

#ifndef SOWIN_FLYVIEWER_H
#define SOWIN_FLYVIEWER_H

#include <Inventor/Win/viewers/SoWinConstrainedViewer.h>

// ************************************************************************

class SOWIN_DLL_API SoWinFlyViewer : public SoWinConstrainedViewer {
  SOWIN_OBJECT_HEADER(SoWinFlyViewer, SoWinConstrainedViewer);
  

public:
  SoWinFlyViewer(
    HWND parent = NULL,
    const char * name = NULL, 
    SbBool embed = TRUE, 
    SoWinFullViewer::BuildFlag flag = BUILD_ALL,
    SoWinViewer::Type type = BROWSER);
  ~SoWinFlyViewer();

  virtual void setViewing(SbBool enable);
  virtual void viewAll(void);
  virtual void resetToHomePosition(void);
  virtual void setCamera(SoCamera * camera);
  virtual void setCursorEnabled(SbBool enable);
  virtual void setCameraType(SoType type);

protected:
  SoWinFlyViewer(
    HWND parent,
    const char * const name, 
    SbBool embed, 
    SoWinFullViewer::BuildFlag flag, 
    SoWinViewer::Type type, 
    SbBool build);

  virtual const char * getDefaultWidgetName(void) const;
  virtual const char * getDefaultTitle(void) const;
  virtual const char * getDefaultIconTitle(void) const;

  virtual SbBool processSoEvent(const SoEvent * const event);
  virtual void setSeekMode(SbBool enable);
  virtual void actualRedraw(void);

  virtual void rightWheelMotion(float value);

  virtual void createPrefSheet(void);
  virtual void openViewerHelpCard(void);

  virtual void afterRealizeHook(void);

private:
  void constructor(SbBool build);
  class SoWinFlyViewerP * pimpl;

}; // class SoWinFlyViewer

// ************************************************************************

#endif // ! SOWIN_FLYVIEWER_H
