#include <stdlib.h>
#include <math.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <HEPVis/nodes/SoBackPrimitive.h>

#include <HEPVis/nodekits/SoForm.h>
#include <HEPVis/nodekits/SoPushButton.h>
#include <HEPVis/nodekits/SoList.h>

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();

  SoPrimitive::initClass();
  SoForm::initClass();
  SoList::initClass();
  SoPushButton::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->height.setValue(2.);
  camera->position.setValue(0.,0.,4.);
  camera->nearDistance.setValue(1.);
  camera->farDistance.setValue(100.);
  sceneGraph->addChild(camera);

  SoForm* form = new SoForm;
  form->background.setValue(1.,0.,0.);
  sceneGraph->addChild(form);

  SoList* list = new SoList;
  list->background.setValue(0.,1.,0.);
  SbString* strings = new SbString[3];
  strings[0] = "item 1";
  strings[1] = "item 2";
  strings[2] = "item 3";
  list->items.setValues(0,3,strings);
  delete [] strings;
  form->addChild(list);

  SoPushButton* pushButton = new SoPushButton;
  pushButton->background.setValue(0.,1.,1.);
  pushButton->labelString.setValue("Exit");
  pushButton->leftAttachment.setValue(SoPrimitive::ATTACH_NODE);
  pushButton->leftNode.setValue(list);
  pushButton->topAttachment.setValue(SoPrimitive::ATTACH_OPPOSITE_NODE);
  pushButton->topNode.setValue(list);
  form->addChild(pushButton);

  pushButton = new SoPushButton;
  pushButton->background.setValue(0.,1.,1.);
  pushButton->labelString.setValue("Next");
  pushButton->leftAttachment.setValue(SoPrimitive::ATTACH_NODE);
  pushButton->leftNode.setValue(list);
  pushButton->bottomAttachment.setValue(SoPrimitive::ATTACH_OPPOSITE_NODE);
  pushButton->bottomNode.setValue(list);
  form->addChild(pushButton);

  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(myWindow);
  viewer->setSceneGraph(sceneGraph);
  //debug viewer->viewAll();
  viewer->setSize(SbVec2s(600,400));
  viewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoPushButton::clearClass();
  SoPrimitive::clearClass();
  SoForm::clearClass();
  SoList::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return EXIT_SUCCESS; 

}
