
#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoLightModel.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoFaceSet.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#define LIST_SET(list,number,x,y,z) list[number].setValue((x),(y),(z))

int main(int aArgc, char** aArgv) {

  // Set up the main window
 
  SoGuiWidget widget=SoGui::init(aArgv[0]);
  if (!widget) exit(1);

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  SoLightModel* lightModel = new SoLightModel;
  lightModel->model.setValue(SoLightModel::PHONG);
  sceneGraph->addChild(lightModel);

 {SoSeparator* sep = new SoSeparator;
  sceneGraph->addChild(sep);

  SoMaterial* material =  new SoMaterial();
  material->diffuseColor.setValue(1,0,0);
  sep->addChild(material);

  SbVec3f points[3];  
  LIST_SET(points,0,0.02,29,-800);
  LIST_SET(points,1,0.02,34.9231,-835);
  LIST_SET(points,2,-17.4415,30.2443,-835);

  SoCoordinate3* coordinate3 = new SoCoordinate3;
  coordinate3->point.setValues(0,3,points);
  sep->addChild(coordinate3);

  SoFaceSet* faceSet = new SoFaceSet;
  faceSet->numVertices.set1Value(0,3);
  sep->addChild(faceSet);}

 {SoSeparator* sep = new SoSeparator;
  sceneGraph->addChild(sep);

  SoMaterial* material =  new SoMaterial();
  material->diffuseColor.setValue(0,1,0);
  sep->addChild(material);

  SbVec3f points[3];  
  LIST_SET(points,0,17.464,30.2461,-834.999);
  LIST_SET(points,1,0.00248,40.0018,-864.999);
  LIST_SET(points,2,0.00248,34.9249,-834.999);

  SoCoordinate3* coordinate3 = new SoCoordinate3;
  coordinate3->point.setValues(0,3,points);
  sep->addChild(coordinate3);

  SoFaceSet* faceSet = new SoFaceSet;
  faceSet->numVertices.set1Value(0,3);
  sep->addChild(faceSet);}


  SoGuiExaminerViewer* examinerViewer = NULL;
  examinerViewer = new SoGuiExaminerViewer(widget);
  examinerViewer->setCameraType(SoOrthographicCamera::getClassTypeId());
  examinerViewer->setSceneGraph(sceneGraph);
  examinerViewer->viewAll();
  examinerViewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete examinerViewer;

  return 0; 
}
