#ifndef HEPVis_SoSDL_Viewer_h
#define HEPVis_SoSDL_Viewer_h

// inheritance :
#include <Inventor/SDL/viewers/SoSDL_Viewer.h>

class SoRegion;
class SoFormRegion;
class SoSimpleButton;

namespace HEPVis {

class SoSDL_Viewer : public ::SoSDL_Viewer {
public:
  SoSDL_Viewer(SoSDL_Widget* aWidget);
  virtual ~SoSDL_Viewer();
public:
  void setShootRegion(SoRegion*);
  void setOptionsRegion(SoFormRegion*);
  SoRegion* optionRegion() const;
  SoRegion* shootRegion() const;

  SbBool showShoot(SbBool& aRender);
  SbBool activate(SbBool aDown,SbBool& aRender);

  SbBool showUI(SbBool& aRender);
  SbBool uiVisible() const;
  void nextUI();
  void prevUI();
private:
  SbBool activateUI(SbBool);
  SoSimpleButton* getButton(int);
private:
  SoRegion* fShootRegion;
  SoFormRegion* fUI;
  int fUI_current;
  SbBool fJoy_state;
};

}

#endif
