// this :
#include <HEPVis/GLUT/viewers/SoGLUT_Viewer.h>

#include <HEPVis/SbColors.h>
#include <HEPVis/nodes/SoAreaStyle.h>
#include <HEPVis/nodekits/SoFormRegion.h>
#include <HEPVis/nodekits/SoSimpleButton.h>

HEPVis::SoGLUT_Viewer::SoGLUT_Viewer(SoGLUT_Widget* aWidget)
: ::SoGLUT_Viewer(aWidget)
,fShootRegion(0)
,fUI(0)
,fUI_current(0)
,fJoy_state(FALSE)
{}

HEPVis::SoGLUT_Viewer::~SoGLUT_Viewer(){}

void HEPVis::SoGLUT_Viewer::setShootRegion(SoRegion* aRegion) {
  fShootRegion = aRegion;
}
void HEPVis::SoGLUT_Viewer::setOptionsRegion(SoFormRegion* aRegion) {
  fUI = aRegion;  
}
SoRegion* HEPVis::SoGLUT_Viewer::optionRegion() const {
  return fUI;  
}
SoRegion* HEPVis::SoGLUT_Viewer::shootRegion() const {
  return fShootRegion;
}

SbBool HEPVis::SoGLUT_Viewer::processKeyboard(unsigned char aChar,SbBool& aRender){
  //NOTE : we can't differenciate key down / key up.
  //       activateUI() modified compared to SDL.

  if(aChar==27) { //ESCAPE //map the options
    return showUI(aRender);
  }
  if(aChar==13) { //RETURN
    return shoot(aRender);
  }
  if(aChar=='r') {
    return showShoot(aRender);
  }

  //

  return ::SoGLUT_Viewer::processKeyboard(aChar,aRender);
}

SbBool HEPVis::SoGLUT_Viewer::processSpecial(int aKey,SbBool& aRender){
  if(fUI && (fUI->visible.getValue()==TRUE) ) { //move in menu.
    if(aKey==GLUT_KEY_RIGHT) {
      nextUI();
      aRender = TRUE;
      return TRUE;
    }
    if(aKey==GLUT_KEY_LEFT) {
      prevUI();
      aRender = TRUE;
      return TRUE;
    }
    if(aKey==GLUT_KEY_UP) {
      return TRUE;
    }
    if(aKey==GLUT_KEY_DOWN) {
      return TRUE;
    }
  } 

  return ::SoGLUT_Viewer::processSpecial(aKey,aRender);
}

SbBool HEPVis::SoGLUT_Viewer::showUI(SbBool& aRender) {
  aRender = FALSE;
  if(!fUI) return FALSE;
  if(fUI->visible.getValue()==FALSE) {
    fUI->visible.setValue(TRUE);  
    int shapen = fUI->shapes.getNum();
    if( (shapen>0) && (fUI_current>=0) && (fUI_current<shapen) ) {
      SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
      button->getBackStyle()->color.setValue(SbColor_red);
    }
    aRender = TRUE;
    return TRUE;
  } else {
    fUI->visible.setValue(FALSE);  
    aRender = TRUE;
    return TRUE;
  }
}  
void HEPVis::SoGLUT_Viewer::nextUI() {
 {SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
  button->getBackStyle()->color.setValue(SbColor_white);}
  fUI_current++;
  if(fUI_current>=fUI->shapes.getNum()) fUI_current = 0;
  SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
  button->getBackStyle()->color.setValue(SbColor_red);
}
void HEPVis::SoGLUT_Viewer::prevUI() {
 {SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
  button->getBackStyle()->color.setValue(SbColor_white);}
  fUI_current--;
  if(fUI_current<0) fUI_current = fUI->shapes.getNum()-1;
  SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
  button->getBackStyle()->color.setValue(SbColor_red);
}
SbBool HEPVis::SoGLUT_Viewer::activateUI() {
  if(!fUI) return FALSE;
  if(fUI->visible.getValue()==FALSE) return FALSE;
  if(fUI_current==-1) return FALSE;
  //In principle SimpleButton::invokeCallbacks on up only.
  SoSimpleButton* button = (SoSimpleButton*)fUI->shapes[fUI_current];
  button->invokeCallbacks();
  return TRUE;
}
SbBool HEPVis::SoGLUT_Viewer::showShoot(SbBool& aRender) {
  aRender = FALSE;
  if(!fShootRegion) return FALSE;
  fShootRegion->visible.setValue
    (fShootRegion->visible.getValue()==FALSE?TRUE:FALSE);
  aRender = TRUE;
  return TRUE;
}
SbBool HEPVis::SoGLUT_Viewer::shoot(SbBool& aRender) {
  if(activateUI()==TRUE) {
    aRender = TRUE;
    return TRUE;
  } else {
    if(fShootRegion) {
      if(fShootRegion->visible.getValue()==TRUE) {
        //if(aDown==TRUE) {
        return emulateLeftButtonDown(aRender);
        //} else {
        //return emulateLeftButtonUp(aRender);
	//}
      } else { 
        return FALSE;
      }
    } else {
      return FALSE;
    }
  }
}
