//////////////////////////////////////////////////////////////////////////////
/// Pre SWIG /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// Utils :
RefCount(SoLineStyle)
RefCount(SoTextStyle)
RefCount(SoAreaStyle)
RefCount(SoStyle)
RefCount(SoMarkerSet)
RefCount(SoImage)
RefCount(SoImageWriter)
RefCount(SoViewportRegion)
RefCount(SoTextHershey)
RefCount(SoTextVtk)
RefCount(SoTextTTF)
RefCount(SoGrid)
RefCount(SoEdgedFaceSet)
RefCount(SoHighlightMaterial)
RefCount(SoSplineCurve)
RefCount(SoPyramid)
RefCount(SoAxis)
RefCount(SoAxes2D)
RefCount(SoAxes3D)
RefCount(SoSimpleButton)
RefCount(SoRegion)
RefCount(SoTextRegion)
RefCount(SoImageRegion)
RefCount(SoDisplayRegion)
RefCount(SoRulerRegion)
RefCount(SoFormRegion)
RefCount(SoCanvas)
RefCount(SoPage)

// Geometry :
RefCount(SoPolyhedron)
RefCount(SoTubs)
RefCount(SoBox)
RefCount(SoTrd)
RefCount(SoBox)
RefCount(SoCons)
RefCount(SoTrap)
RefCount(SoTrd)
RefCount(SoTubs)
RefCount(SoArrow)
RefCount(SoEllipsoid)
RefCount(SoEllipsoidSegment)
RefCount(SoEllipticalPrism)
RefCount(SoTorus)
RefCount(SoPcon)
RefCount(SoPcons)
RefCount(SoPolyVol)
RefCount(So3DErrorBar)
RefCount(SoCoordinateAxis)
RefCount(SoWedge)
RefCount(So2DArrow)
RefCount(SoCircleArc)
RefCount(SoDisk)
RefCount(SoPolygon)
RefCount(SoQuad)
RefCount(SoRing)
RefCount(SoTriangle)

// Detector :
RefCount(SoHelicalTrack)
RefCount(SoCrystalHit)
RefCount(SoJet)
RefCount(SoReconTrack)
RefCount(SoSiStrips)
RefCount(SoSiWedgeStrips)
RefCount(SoVtxReconTrack)
RefCount(SoHadEmCrystalHit)
RefCount(SoDetectorTreeKit)
RefCount(SoMeterStickKit)
RefCount(SoIdealTrackKit)
RefCount(SoIdealBeamTrackKit)
RefCount(SoDblSiStripDetKit)
RefCount(SoSiStripDetKit)
RefCount(SoStereoSiStripDetKit)
RefCount(SoSiStripWedgeDetKit)
RefCount(SoDblSiStripWedgeDetKit)
RefCount(SoDetectorExample)

// Plotter :
RefCount(SoPlotter)
RefCount(SoLegendRegion)
RefCount(SoInfosRegion)
RefCount(SoPlotterRegion)

// GUI :
RefCount(SoBackPrimitive)
RefCount(SoPrimitive)
RefCount(SoForm)
RefCount(SoPushButton)
RefCount(SoArrowButton)
RefCount(SoScrolledList)
RefCount(SoSelectionBox)
RefCount(SoList)
RefCount(SoText)
RefCount(SoCommand)
RefCount(SoFileSelectionBox)
RefCount(SoShell)

// Else :
RefCount(SoStyleCache)


%include std_string.i
%include std_vector.i
%include std_pair.i
%template() std::vector<std::string>;
%template() std::vector<double>;
%template() std::vector<int>;
%template() std::vector<SbStyleColor>;
%template() std::pair<SbString,SbColor>;

%include <HEPVis/SbAll.h>
%include <HEPVis/Utils.h>
%include <HEPVis/Geometry.h>
%include <HEPVis/Detector.h>
%include <HEPVis/Plotter.h>
%include <HEPVis/GUI.h>

#include <HEPVis/misc/SoTools.h>
%include <HEPVis/misc/SoStyleCache.h>

//////////////////////////////////////////////////////////////
/// Post SWIG ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

#ifdef SWIGPYTHON
%pythoncode {

def Utils_initClasses():
  SoLineStyle.initClass()
  SoTextStyle.initClass()
  SoAreaStyle.initClass()
  SoStyle.initClass()
  HEPVis_SoMarkerSet.initClass()
  HEPVis_SoImage.initClass()
  SoImageWriter.initClass()
  SoViewportRegion.initClass()
  SoTextHershey.initClass()
  SoTextTTF.initClass()
  SoTextVtk.initClass()
  SoGrid.initClass()
  SoEdgedFaceSet.initClass()
  SoHighlightMaterial.initClass()
  SoSplineCurve.initClass()
  SoPyramid.initClass()

  SoAxis.initClass()
  SoAxes2D.initClass()
  SoAxes3D.initClass()
  SoSimpleButton.initClass()
  SoRegion.initClass()
  SoTextRegion.initClass()
  SoImageRegion.initClass()
  SoDisplayRegion.initClass()
  SoRulerRegion.initClass()
  SoFormRegion.initClass()
  SoCanvas.initClass()
  SoPage.initClass()

  SoPainterAction.initClass()
  SoGL2PSAction.initClass()
  SoCollectAction.initClass()
  SoCounterAction.initClass()
  SoAlternateRepAction.initClass()

def Geometry_initClasses():
  SoPolyhedron.initClass()
  SoArrow.initClass()
  SoEllipsoid.initClass()
  SoEllipsoidSegment.initClass()
  SoEllipticalPrism.initClass()
  SoBox.initClass()
  SoCons.initClass()
  SoTrap.initClass()
  SoTrd.initClass()
  SoTubs.initClass()
  SoTorus.initClass()
  SoWedge.initClass()
  SoPcon.initClass()
  SoPcons.initClass()
  SoPolyVol.initClass()
  So3DErrorBar.initClass()
  SoCoordinateAxis.initClass()
  So2DArrow.initClass()
  SoCircleArc.initClass()
  SoDisk.initClass()
  SoPolygon.initClass()
  SoQuad.initClass()
  SoRing.initClass()
  SoTriangle.initClass()

def Detector_initClasses():
  SoHelicalTrack.initClass()
  SoCrystalHit.initClass()
  SoJet.initClass()
  SoReconTrack.initClass()
  SoSiStrips.initClass()
  SoSiStripWedgeDetKit.initClass()
  SoVtxReconTrack.initClass()
  SoHadEmCrystalHit.initClass()

  SoDetectorTreeKit.initClass()
  SoMeterStickKit.initClass()
  SoIdealTrackKit.initClass()
  SoIdealBeamTrackKit.initClass()
  SoDblSiStripDetKit.initClass()
  SoSiStripDetKit.initClass()
  SoStereoSiStripDetKit.initClass()
  SoDblSiStripWedgeDetKit.initClass()
  SoSiWedgeStrips.initClass()
  SoDetectorExample.initClass()

def Plotter_initClasses():
  SoPlotter.initClass()
  SoLegendRegion.initClass()
  SoInfosRegion.initClass()
  SoPlotterRegion.initClass()

def GUI_initClasses():
  SoBackPrimitive.initClass()
  SoPrimitive.initClass()
  SoForm.initClass()
  SoPushButton.initClass()
  SoArrowButton.initClass()
  SoScrolledList.initClass()
  SoSelectionBox.initClass()
  SoList.initClass()
  SoText.initClass()
  SoCommand.initClass()
  SoFileSelectionBox.initClass()
  SoShell.initClass()

}
#endif

