/*
 *  SbHatching.cxx
 *  
 *
 *  Created by Laurent Garnier on Jan 30 2004.
 *
 */ 

// this :  
#include <HEPVis/SbHatching.h>

#include <HEPVis/SbMath.h>

SbHatching::SbHatching()
{
  fHatchPointsList.clear();
  fCornerMinBB = SbVec3f(.0f,.0f,.0f);
  fCornerMaxBB = SbVec3f(.0f,.0f,.0f);
}


SbHatching::~SbHatching() { 
}

int SbHatching::addPolyline(SbVec3f* Coord,int aNumber){
  int res = checkPolyline(Coord,aNumber);
  
  if (res == TRUE) {    
    if (getStripWidth() ==0) {
      res = computePolyline(Coord,aNumber);}
    else
      res = computePolyline(Coord,aNumber);
    for (unsigned int i=0;i<getNoVertices();i++) {
      fHatchNumVerticesList.push_back(getVertices()[i]);
    }    
    if (res == TRUE){
      for (unsigned int i=0;i<getNoPoints();i++) {
        fHatchPointsList.push_back(getPoints()[i]);

        if (getPoints()[i].getValue()[0] <fCornerMinBB[0]) fCornerMinBB[0] = getPoints()[i].getValue()[0];
        if (getPoints()[i].getValue()[1] <fCornerMinBB[1]) fCornerMinBB[1] = getPoints()[i].getValue()[1];
        if (getPoints()[i].getValue()[2] <fCornerMinBB[2]) fCornerMinBB[2] = getPoints()[i].getValue()[2];
        
        if (getPoints()[i].getValue()[0] >fCornerMaxBB[0]) fCornerMaxBB[0] = getPoints()[i].getValue()[0];
        if (getPoints()[i].getValue()[1] >fCornerMaxBB[1]) fCornerMaxBB[1] = getPoints()[i].getValue()[1];
        if (getPoints()[i].getValue()[2] >fCornerMaxBB[2]) fCornerMaxBB[2] = getPoints()[i].getValue()[2];
      }    
    } else {
      printf("SbHatching::addPolyline : ERROR in SbHatching::computePolyline. Points (%d) :\n",aNumber);
      for (int i=0;i<aNumber;i++) {
         printf("SbHatching::addPolyline :  %d : %g %g %g\n",i,Coord[i][0],Coord[i][1],Coord[i][2]);
      }
    }
  }
  return res;
}

const std::vector<SbVec3f>& SbHatching::getHatchPointsList() const {
  return fHatchPointsList;
}
const unsigned int SbHatching::getNumPointsList() const {
  return fHatchPointsList.size();
}
const std::vector<unsigned int>& SbHatching::getHatchNumVerticesList() const {
  return fHatchNumVerticesList;
}
const unsigned int SbHatching::getNumVertices() const {
  return fHatchNumVerticesList.size();
}
const SbVec3f& SbHatching::getCornerMinBB() {
  return fCornerMinBB;
}
const SbVec3f& SbHatching::getCornerMaxBB() {
  return fCornerMaxBB;
}
