// this :
#include <HEPVis/SbMath.h>

#include <Inventor/errors/SoDebugError.h>

//////////////////////////////////////////////////////////////////////////////
int SbFROUND(
 float aFloat
)
//////////////////////////////////////////////////////////////////////////////
// From CoinGL/src/base/SbViewportRegion.cpp.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if (aFloat == (float) (int(aFloat))) return int(aFloat);
  else return (aFloat>0.0f) ? int(aFloat+0.5f) : -int(0.5f-aFloat);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
SbLagrangePolynomial::SbLagrangePolynomial(
 int aNumber
,float* aXs
,float* aYs
)
:fNumber(0)
,fXs(0)
,fYs(0)
,fDenominators(0)
//////////////////////////////////////////////////////////////////////////////
// aYs and aXs must be of size aNumber.
// WARNING : All the aXs must have a different value !
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aNumber<=0) return;

  // Check aXs :
 {for(int i = 0;i<aNumber;i++) {
    //printf("debug : %d (%d) : %g %g\n",i,aNumber,aXs[i],aYs[i]);
    for(int j = i+1;j<aNumber;j++) {
      if(aXs[j]==aXs[i]) {
        SoDebugError::postInfo("SbLagrangePolynomial::SbLagrangePolynomial",
        "%d and %d points have same X (%g %g) (%g %g)",
        i,j,aXs[i],aYs[i],aXs[j],aYs[j]);
        return;
      }
    }
  }}

  fXs = new float[aNumber];
  fYs = new float[aNumber];
  for(int i = 0;i<aNumber;i++) {
    fXs[i] = aXs[i];
    fYs[i] = aYs[i];
  }

  // Initialize :
  fDenominators = new float[aNumber];
 {for(int i = 0;i<aNumber;i++) {
    fDenominators[i] = 1;
    for(int j = 0;j<aNumber;j++) {
      if(j==i) continue;
      fDenominators[i] *= (aXs[i]-aXs[j]);
    }
  }}

  fNumber = aNumber;
}
//////////////////////////////////////////////////////////////////////////////
SbLagrangePolynomial::~SbLagrangePolynomial(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete [] fDenominators;
  delete [] fXs;
  delete [] fYs;
}
//////////////////////////////////////////////////////////////////////////////
SbBool SbLagrangePolynomial::isValid(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return (fNumber<=0?FALSE:TRUE);
}
//////////////////////////////////////////////////////////////////////////////
float SbLagrangePolynomial::getValue(
 float aX
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fNumber<=0) return 0;
  float Y = 0;
  for(int i = 0;i<fNumber;i++) {
    float numerator = 1;
    for(int j = 0;j<fNumber;j++) {
      if(j==i) continue;
      numerator *= (aX - fXs[j]);
    }
    Y += fYs[i] * numerator/fDenominators[i];
  }
  return Y;
}
