// this :
#include <HEPVis/draggers/SoDragPoint2D.h>

// Inventor :
#include <Inventor/nodes/SoCoordinate3.h>

#define NotFound (-1)

void SoDragPoint2D::updateCoordinate3(){}

void SoDragPoint2D::motion_dragger_CB(void*,SoDragger* aDragger) {
  SoDragPoint2D* This = (SoDragPoint2D*)aDragger;
  const SbVec3f& v = This->translation.getValue();
  //printf("debug : motion_dragger_CB : %g %g %g\n",v[0],v[1],v[2]);
  This->fCoord.point.set1Value(This->fIndex,This->fStart+v*This->fScale);
  if(This->fIndex==0) {
    int num = This->fCoord.point.getNum();
    This->fCoord.point.set1Value(num-1,This->fStart+v*This->fScale);
  }
  This->updateCoordinate3();
}
SoDragPoint2D::SoDragPoint2D(SoCoordinate3& aCoord,int aIndex,float aScale)
:fCoord(aCoord),fIndex(NotFound),fScale(aScale){
  //NOTE : we assume that aCoord contains a closed polyline.
  fCoord.ref();
  int num = fCoord.point.getNum();
  if((aIndex>=0)&&(aIndex<(num-1))) {
    fIndex = aIndex;  
    fStart = fCoord.point[aIndex];
    SoDragger::addMotionCallback(motion_dragger_CB);
  }
}
SoDragPoint2D::~SoDragPoint2D(){
  fCoord.unref();
  if(fIndex!=NotFound) {
    SoDragger::removeMotionCallback(motion_dragger_CB);
  }
}
const SbVec3f& SoDragPoint2D::point() const {return fCoord.point[fIndex];}
int SoDragPoint2D::index() const {return fIndex;}
SoCoordinate3& SoDragPoint2D::coordinate3() const {return fCoord;}

