//  September/2009 : G.Barrand : creation.

#ifndef SoGLUT_SoGLUT_h
#define SoGLUT_SoGLUT_h 

// glut :
#ifdef APPLE_GLUT
#include <glut.h>
#else
#include <GL/glut.h>
#endif

#include <Inventor/SbBasic.h>
#include <Inventor/SbString.h>

class SoGLUT_Viewer;

class SoGLUT_Widget {
public:
  SoGLUT_Widget();
  virtual~ SoGLUT_Widget();
  void setViewer(SoGLUT_Viewer*); //FIXME
  SoGLUT_Viewer* getViewer() const; //FIXME
private:  
  SoGLUT_Viewer* fViewer; //FIXME
};

class SoGLUT {
public:
  static SoGLUT_Widget* init(int& argc,char** argv,
                             const char* appname,
                             const char* classname = "SoXt",
                             int x = 0,int y = 0,
                             int w = 500,int h = 500,
                             bool a_full_screen = true);
  static void show(SoGLUT_Widget*);
  static void mainLoop();
  
  static void clear();
  static void toQuit();
private:
  static void display();
  static void reshape(int,int);
  static void keyboard(unsigned char,int,int);
  static void special(int,int,int);
  static void mouse(int,int,int,int);
  static void motion(int,int);
  static void joystick(unsigned int,int,int,int);
  static void idle();
  static void mainTimer(int);
private:
  static SoGLUT_Widget* fWidget;
  static SbBool fToQuit;
};

#endif
