//  Mai/2007 : G.Barrand : creation.

// this :
#include <Inventor/GLUT/SoGLUT.h>
   
// Inventor :
#include <Inventor/SoDB.h>
#include <Inventor/SbTime.h>
#include <Inventor/SbVec2s.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/nodekits/SoNodeKit.h>

#include <Inventor/GLUT/viewers/SoGLUT_Viewer.h> //FIXME

#include <cstring>

SoGLUT_Widget* SoGLUT::fWidget = 0;
SbBool SoGLUT::fToQuit = FALSE;

SoGLUT_Widget::SoGLUT_Widget():fViewer(0){}
SoGLUT_Widget::~SoGLUT_Widget() {}

// FIXME : at end, have to rm this method.
void SoGLUT_Widget::setViewer(SoGLUT_Viewer* aViewer) {fViewer = aViewer;}

// FIXME : at end have to rm this method.
SoGLUT_Viewer* SoGLUT_Widget::getViewer() const {return fViewer;}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void SoGLUT::reshape(int a_w,int a_h){
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  viewer->setSize(SbVec2s(a_w,a_h));
}

void SoGLUT::display(void){
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);
  viewer->render();
  glutSwapBuffers();
}

void SoGLUT::keyboard(unsigned char a_char,int a_x,int a_y){
  //printf("debug : keyboard : %d \"%c\"\n",a_char,a_char);
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  SbBool render;
  if(viewer->processKeyboard(a_char,render)==TRUE) {
    if(render==TRUE) glutPostRedisplay();
    return;
  }
  if(a_char=='q') {
    ::exit(0);
  }
}
void SoGLUT::special(int a_key,int a_x,int a_y){
  //printf("debug : special : %d\n",a_key);
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  SbBool render;
  if(viewer->processSpecial(a_key,render)==TRUE) {
    if(render==TRUE) glutPostRedisplay();
  }
}
void SoGLUT::mouse(int a_button,int a_state,int a_x,int a_y){
  //printf("debug : mouse : %d\n",a_button);
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  SbBool render;
  if(viewer->processMouse(a_button,a_state,a_x,a_y,render)==TRUE) {
    if(render==TRUE) glutPostRedisplay();
  }
}
void SoGLUT::motion(int a_x,int a_y){
  //printf("debug : motion : %d %d\n",a_x,a_y);
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  SbBool render;
  if(viewer->processMotion(a_x,a_y,render)==TRUE) {
    if(render==TRUE) glutPostRedisplay();
  }
}

void SoGLUT::joystick(unsigned int a_button,int a_x,int a_y,int a_z){
  printf("debug : joystick : %d %d %d\n",a_button,a_x,a_y,a_z);
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;
  SbBool render;
  if(viewer->processJoystick(a_button,a_x,a_y,a_z,render)==TRUE) {
    if(render==TRUE) glutPostRedisplay();
  }
}

void SoGLUT::idle(){
  //printf("debug : idle\n");
}

void SoGLUT::mainTimer(int){
  //printf("debug : mainTimer\n");
  SoSensorManager* sensorManager = SoDB::getSensorManager();
  if(sensorManager) {
    SbBool render = FALSE;
    //sendMessage(SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_IDLE);
    if (sensorManager->isDelaySensorPending()) {
      sensorManager->processDelayQueue(TRUE);
      render = TRUE;
    }
    //sendMessage(SoSDL_USEREVENT_PROCESS_TIMER_QUEUE);
    SbTime timevalue;
    if(sensorManager->isTimerSensorPending(timevalue)) {
      sensorManager->processTimerQueue();
      render = TRUE;
    }
    if(render==TRUE) glutPostRedisplay();
  }

  glutTimerFunc(50,mainTimer,0);

}

SoGLUT_Widget* SoGLUT::init(int& a_argc,char** a_argv,
                            const char* a_appname,
			    const char* a_classname,
                            int a_wx,int a_wy,
                            int a_ww,int a_wh,
                            bool a_full_screen){

  glutInit(&a_argc,a_argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH | GLUT_MULTISAMPLE);

  glutSetKeyRepeat(GLUT_KEY_REPEAT_ON);

  //FIXME : in SoGLUT_Viewer ?
  glutInitWindowPosition(a_wx,a_wy);
  glutInitWindowSize(a_ww,a_wh);
  glutCreateWindow("SoGLUT");

  if(a_full_screen) glutFullScreen(); //Must come after having a window.

  //glShadeModel(GL_FLAT);

  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(special);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutIdleFunc(idle);

  /*
  printf("debug : joystick infos : %d %d %d %d %d\n",
	 glutDeviceGet(GLUT_HAS_JOYSTICK),
	 glutDeviceGet(GLUT_OWNS_JOYSTICK),
	 glutDeviceGet(GLUT_JOYSTICK_BUTTONS),
	 glutDeviceGet(GLUT_JOYSTICK_AXES),
         glutDeviceGet(GLUT_JOYSTICK_POLL_RATE));
  */
  if(glutDeviceGet(GLUT_HAS_JOYSTICK))
    glutJoystickFunc(joystick,30);

  if(!SoDB::isInitialized()) SoDB::init();
  SoNodeKit::init();
  SoInteraction::init();

  glutTimerFunc(50,mainTimer,0);

  fWidget = new SoGLUT_Widget();
  return fWidget;
}

void SoGLUT::show(SoGLUT_Widget*) {}
void SoGLUT::clear() {
  //FIXME : glutQuit();
  delete fWidget;
  fWidget = 0;
}

void SoGLUT::mainLoop() {
  SoSensorManager* sensorManager = SoDB::getSensorManager();
  if(!sensorManager) return;

  if(!fWidget) return;

  //FIXME : at end, the below should disappear :
  SoGLUT_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;

  glutMainLoop ();

}

void SoGLUT::toQuit(){fToQuit = TRUE;}
