#ifndef Lib_InternetSocket_h
#define Lib_InternetSocket_h

// Inheritance :
#include <Lib/BaseSocket.h>

namespace Lib {

class InternetSocket : public BaseSocket { 
public: //BaseSocket        
  virtual bool accept();
  virtual bool connect();
  virtual void disconnect();
public:        
  InternetSocket(std::ostream&,const std::string& host,int port,int = 0);  
  virtual ~InternetSocket();
private:
  InternetSocket(const InternetSocket&);
  InternetSocket& operator=(const InternetSocket&);
public:        
  void setPort(int);
  int port() const;
  void setHost(const std::string&);
  typedef bool(*AfterBindingFunc)(void*);
  void setAfterBindingFunc(AfterBindingFunc,void*);
protected:        
  std::string fHost;
  int fPort;
  AfterBindingFunc fAfterBindingFunc;
  void* fAfterBindingTag;
};

}

#endif

