#ifndef SoSDL_SoMain_h
#define SoSDL_SoMain_h

#include <Inventor/fields/SoSFUInt32.h>
#include <Inventor/fields/SoSFBool.h>

// To customize the program from a .iv
class SoMain : public SoNode {
  SO_NODE_HEADER(SoMain);
public:
  SoSFUInt32 keyRepeatDelay;
  SoSFUInt32 keyRepeatInterval;

  SoSFFloat deltaTranslation;
  SoSFFloat deltaRotation;
  //SoSFUInt32 moveTimerInterval;

  SoSFBool checkFloor;
  SoSFFloat floor;

  SoSFVec3f camera_position;
  SoSFFloat camera_nearDistance;
  SoSFFloat camera_farDistance;
  SoSFFloat camera_focalDistance;

  SoSFBool sceneRenderCaching;
public:
  SoMain() {
    SO_NODE_CONSTRUCTOR(SoMain);

    SO_NODE_ADD_FIELD(keyRepeatDelay,(200));
    SO_NODE_ADD_FIELD(keyRepeatInterval,(10));

    SO_NODE_ADD_FIELD(deltaTranslation,(1.0F));
    SO_NODE_ADD_FIELD(deltaRotation,(3.1416F/180.0F));
    //SO_NODE_ADD_FIELD(moveTimerInterval,(30));

    SO_NODE_ADD_FIELD(checkFloor,(FALSE));
    SO_NODE_ADD_FIELD(floor,(0.0));

    //SoCamera defaults :
    SO_NODE_ADD_FIELD(camera_position,(0,0,1));
    SO_NODE_ADD_FIELD(camera_nearDistance, (1.0f));
    SO_NODE_ADD_FIELD(camera_farDistance, (10.0f));
    SO_NODE_ADD_FIELD(camera_focalDistance, (5.0f));

    SO_NODE_ADD_FIELD(sceneRenderCaching,(FALSE));
  }
  static void initClass() {
    SO_NODE_INIT_CLASS(SoMain,SoNode,"Node");
  }
protected:
  virtual ~SoMain(){}
};
SO_NODE_SOURCE(SoMain)

#endif
