// this :
#include "SoOrthoCamera.h"

#include <Inventor/errors/SoDebugError.h>

SO_NODE_SOURCE(SoOrthoCamera)

void SoOrthoCamera::initClass() {
  SO_NODE_INIT_CLASS(SoOrthoCamera,SoOrthographicCamera,"OrthographicCamera");
}
SoOrthoCamera::SoOrthoCamera() {
  SO_NODE_CONSTRUCTOR(SoOrthoCamera);

  SO_NODE_ADD_FIELD(left,   (-0.5F));
  SO_NODE_ADD_FIELD(right,  (0.5F));
  SO_NODE_ADD_FIELD(bottom, (-0.5F));
  SO_NODE_ADD_FIELD(top,    (0.5F));
}
SoOrthoCamera::~SoOrthoCamera(){}

void SoOrthoCamera::scaleHeight(float aFactor) {
  //::printf("debug : SoOrthoCamera::scaleHeight\n");
  top.setValue(top.getValue() * aFactor);
  bottom.setValue(bottom.getValue() * aFactor);
}

SbViewVolume SoOrthoCamera::getViewVolume(float aAspect) const {
  SbViewVolume volume;

  //::printf("debug : SoOrthoCamera::getViewVolume : %g %g : %g %g : %g %g\n",
  //   left.getValue(),right.getValue(),
  //   bottom.getValue(),top.getValue(),
  //   nearDistance.getValue(),farDistance.getValue());

  volume.ortho(left.getValue()  , right.getValue(),
               bottom.getValue(), top.getValue(),
               nearDistance.getValue(), farDistance.getValue());
  
  volume.rotateCamera(orientation.getValue());
  volume.translateCamera(position.getValue());

  return volume;
}
void SoOrthoCamera::viewBoundingBox(const SbBox3f& aBox,float aAspect, float aSlack){
  //FIXME : let the printf to remember that we have not yet
  //        examined what exactly to do here.
  ::printf("debug : SoOrthoCamera::viewBoundingBox\n");
  SoOrthographicCamera::viewBoundingBox(aBox,aAspect,aSlack);
}
