@ECHO OFF
SETLOCAL

REM #////////////////////////////////////////////////
REM # Check that VisualC++ environment is available :
REM #////////////////////////////////////////////////
CL.exe 1> NUL 2> NUL
IF ERRORLEVEL 1 (
  ECHO CL.exe program not found. You have to setup VisualC++ environment.
  GOTO to_return
)

REM #////////////////////////////////////////////////
REM # Look for coin-config :
REM #////////////////////////////////////////////////
FOR /F "usebackq delims=;" %%s IN (`coin-config --cppflags`) DO SET coin_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`coin-config --libs`) DO SET coin_libs=%%s

REM #////////////////////////////////////////////////
REM # Look for SDL :
REM #////////////////////////////////////////////////
SET SDL_home=C:\usr\local\SDL\1.2.11
IF NOT EXIST %SDL_home% (
  ECHO SDL not under %SDL_home%
  ECHO Edit the build.bat script to set properly
  ECHO the SDL_home, SDL_cppflags, SDL_libs, SDL_main variables.
  GOTO to_return
)
SET SDL_cppflags=/I%SDL_home%\include
SET SDL_libs=%SDL_home%\lib\SDL.lib
SET SDL_main=%SDL_home%\lib\SDLmain.lib

REM #////////////////////////////////////////////////
REM # Build the SDL.lib library :
REM #////////////////////////////////////////////////
REM # /GR to enable RTTI and dynamic cast.
REM # /GX to enable exception handling (for STL).
REM # /O2 optimize
REM # /W3 warmings
SET bin=.
SET cppflags=/nologo /DWIN32 /MD /GX /GR /O2 /W3 /I .
SET cppflags=%cppflags% /I..\include
SET cppflags=%cppflags% %coin_cppflags% %SDL_cppflags%
cl.exe /c %cppflags% %coin_cppflags% /Fo%bin%\SoSDL.obj /Tp..\src\Inventor\SDL\SoSDL.cpp
IF ERRORLEVEL 1 GOTO to_return

cl.exe /c %cppflags% %coin_cppflags% /Fo%bin%\SoSDL_Viewer.obj /Tp..\src\Inventor\SDL\viewers\SoSDL_Viewer.cpp
IF ERRORLEVEL 1 GOTO to_return

lib.exe /nologo /machine:ix86 /out:%bin%\SoSDL.lib %bin%\SoSDL.obj %bin%\SoSDL_Viewer.obj

REM #/////////////////////////////////////////
REM # Build the SoSDL_test_cube application :
REM #/////////////////////////////////////////

cl.exe /c %cppflags% %coin_cppflags% /Fo%bin%\SoSDL_test_cube.obj /Tp..\tests\SoSDL_test_cube.cpp
link.exe /nologo /subsystem:windows /out:%bin%\SoSDL_test_cube.exe %SDL_main% %bin%\SoSDL_test_cube.obj %bin%\SoSDL.lib %coin_libs% %SDL_libs%
REM link.exe /nologo /subsystem:console /out:%bin%\SoSDL_test_cube.exe %SDL_main% %bin%\SoSDL_test_cube.obj %bin%\SoSDL.lib %coin_libs% %SDL_libs%

del %bin%\SoSDL.obj
del %bin%\SoSDL_Viewer.obj
del %bin%\SoSDL_test_cube.obj

:to_return
ENDLOCAL
@ECHO on
