
#include <Lib/Debug.h>

#include <Lib/Out.h>
#include <Lib/sout.h>

#include <list>

static bool sCheckByClass = false;
static int sCount = 0;
static std::list< std::pair<std::string,int> >* sList = 0;

//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::checkByClass(
 bool aEnable
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  sCheckByClass = aEnable;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Debug::checkByClass(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return sCheckByClass;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::increment(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  sCount++;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::decrement(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  sCount--;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::increment(
  const std::string& aClass
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(sCheckByClass) {
    if(!sList) sList = new std::list< std::pair<std::string,int> >;
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=sList->begin();it!=sList->end();++it) {
      if((*it).first==aClass) {
        (*it).second++;
        return;
      }
    }
    sList->push_back(std::pair<std::string,int>(aClass,1));
  } else {
    sCount++;
  }
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::decrement(
  const std::string& aClass
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(sCheckByClass) {
    if(!sList) sList = new std::list< std::pair<std::string,int> >;
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=sList->begin();it!=sList->end();++it) {
      if((*it).first==aClass) {
        (*it).second--;
        return;
      }
    }
    sList->push_back(std::pair<std::string,int>(aClass,-1));
  } else {
    sCount--;
  }
}
//////////////////////////////////////////////////////////////////////////////
Lib::Debug::Debug(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  increment();
}
//////////////////////////////////////////////////////////////////////////////
Lib::Debug::~Debug(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  decrement();
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Debug::balance(
 Slash::Core::IWriter& aPrinter
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(sCount) {
    Out out(aPrinter);
    out << "Lib::Debug::check :"
        << " bad global object balance : " << sCount << endl;
    if(sCheckByClass) {
      out << "Lib::Debug::check :"
          << " check by class was enabled." << endl;
    } else {
      out << "Lib::Debug::check :"
          << " check by class was disabled." << endl;
    }
  }
  if(sList) {
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=sList->begin();it!=sList->end();++it) {
      if((*it).second) {
        Out out(aPrinter);
        out << "Lib::Debug::check :"
            << " for class " << Lib::sout((*it).first) 
            << ", bad object balance : " << (*it).second
            << endl;
      }
    }
    delete sList;
    sList = 0;
  }
}


/*
#include <stdio.h>
class Lib_Debug_DLL {
public:
  Lib_Debug_DLL() {
    printf("debug : Lib_Debug_DLL : +-+-\n");
  }
  virtual ~Lib_Debug_DLL() {
    printf("debug : ~Lib_Debug_DLL : +-+-\n");
  }
};
static Lib_Debug_DLL libDebugDLL;
*/
