#!/bin/sh -f

#
# File produced by the obuild tool version @@obuild_version@@
# for the package @@package@@ with version @@version@@.
#

#////////////////////////////////////////////////
# Usage :
#   UNIX> cd some_path/project/version/obuild
# ( UNIX> chmod a+x sh/build_release )
#   UNIX> sh/build_release
#
#////////////////////////////////////////////////

#obuild_args="$*"

obuild_verbose=no
obuild_set_x=no
obuild_erase_dir_bin=no
obuild_debug_signature=

while test $# -ge 1 ; do
  case $1 in
    -h) 
        echo "Usage :"
        echo "  UNIX> sh/release [Options]"
        echo "Options :"
        echo "  -v : verbose."
        echo "  -x : execute with set -x."
        echo "  -g : debug."
        echo ""
        exit ;;
    -v) obuild_verbose=yes ;;
    -x) obuild_set_x=yes ;;
    -e) obuild_erase_dir_bin=yes ;;
    -g) obuild_debug_signature=-debug ;;
    -*) echo "unknwon option : $1" ; exit ;;
  esac
  shift
done

if [ ${obuild_set_x} = yes ] ; then
  set -x
fi

if [  "${OBUILD_DIR_BIN}" = "" ] ; then
  @@dir_bin_variable@@=bin_obuild
else
  @@dir_bin_variable@@=${OBUILD_DIR_BIN}
fi

if [ "${@@dir_bin_variable@@}" = "" ] ; then
  echo "@@dir_bin_variable@@ variable not defined."
  exit
fi

obuild_pwd=`pwd`
@@path_variable@@=`dirname "${obuild_pwd}"`
unset obuild_pwd

if [ ${obuild_erase_dir_bin} = "yes" ] ; then
  /bin/rm -R -f "@@dir_bin@@"
  exit
fi

# Create the bin directory :
/bin/mkdir -p "@@dir_bin@@"

