
#
#  Usage :
#    sh> . <osc_vis_path>/SDL-setup.sh
#

#set -x

SDL_home="none"
if [ "`uname -n | grep lxplus`" != "" ] ; then
  if [ `uname -m` = "x86_64" ] ; then
    SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_amd64_gcc34"
  else
    SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_ia32_gcc34"
  fi
else
  if [ `uname` = Darwin ] ; then
    SDL_home=/Library/Frameworks
  fi
fi

if [ "${SDL_home}" != "none" ]; then

if [ `uname` = "Linux" ]; then
  lib_path="${SDL_home}/lib"
  if [ -z "${LD_LIBRARY_PATH}" ] ; then
    LD_LIBRARY_PATH="${lib_path}"
    export LD_LIBRARY_PATH
  else
    osc_status=1;(echo $LD_LIBRARY_PATH | grep "${lib_path}" > /dev/null  ) && osc_status=0
    if [ $osc_status != 0 ] ; then
      LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:${lib_path}"
      export LD_LIBRARY_PATH
    fi
    unset osc_status
  fi
  unset lib_path
fi

if [ `uname` = "Darwin" ]; then

  lib_path="${SDL_home}/SDL.framework"

  if [ -z "${DYLD_LIBRARY_PATH}" ] ; then
    DYLD_LIBRARY_PATH="${lib_path}"
    export DYLD_LIBRARY_PATH
  else
    osc_status=1;(echo $DYLD_LIBRARY_PATH | grep "${lib_path}" > /dev/null  ) && osc_status=0
    if [ $osc_status != 0 ] ; then
      DYLD_LIBRARY_PATH="${DYLD_LIBRARY_PATH}:${lib_path}"
      export DYLD_LIBRARY_PATH
    fi
    unset osc_status
  fi
  unset lib_path
fi

bin_path="${SDL_home}/bin"
if [ -z "${PATH}" ] ; then
  PATH="${bin_path}"
  export PATH
else
  osc_status=1;(echo $PATH | grep "${bin_path}" > /dev/null  ) && osc_status=0
  if [ $osc_status != 0 ] ; then
    PATH="${PATH}:${bin_path}"
    export PATH
  fi
  unset osc_status
fi
unset bin_path

fi

unset SDL_home

