@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package osc_iv with version 16.11.8.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_osc_iv_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_osc_iv_path=%obuild_osc_iv_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no
SET obuild_debug_signature=

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  ECHO   -g : debug.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug_signature=-debug
  SHIFT
  GOTO next_arg
:end_if_g

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_osc_iv_path%\%obuild_dir_bin%"
  GOTO obuild_return
)

IF NOT EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_iv_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_osc_iv_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_osc_iv_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET Qt_home=C:\usr\local\Qt\4.4.2
:end_if_platform_1
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET Qt_moc=%Qt_home%\bin\moc
:end_if_platform_3
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET Python_home=C:\usr\local\Python\2.5
:end_if_platform_5
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET Python_version=25
:end_if_platform_7
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_9
SET SDL_home=C:\usr\local\SDL\1.2.11
:end_if_platform_9
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_11
SET curl_home=C:\usr\local\curl\7.15.1
:end_if_platform_11
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_0=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF EXIST osc_iv RMDIR /S /Q osc_iv
IF NOT EXIST osc_iv MKDIR osc_iv
cd osc_iv
IF NOT EXIST 16.11.8 MKDIR 16.11.8
cd 16.11.8
IF NOT EXIST lib MKDIR lib
IF NOT EXIST bin MKDIR bin
IF NOT EXIST Resources MKDIR Resources
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_project=%%d

IF EXIST "%obuild_dir_project%\Versions" DEL "%obuild_dir_project%\Versions"
ECHO package foreign v1r10p0   >> "%obuild_dir_project%\Versions"
ECHO package CoinGL v1r250p6   >> "%obuild_dir_project%\Versions"
ECHO package CoinGtk v1r50p10   >> "%obuild_dir_project%\Versions"
ECHO package CoinWin v1r50p14   >> "%obuild_dir_project%\Versions"
ECHO package CoinQt v1r130p8   >> "%obuild_dir_project%\Versions"
ECHO package CoinXt v1r122p9   >> "%obuild_dir_project%\Versions"
ECHO package CoinPython v1r0p12   >> "%obuild_dir_project%\Versions"
ECHO package SoSDL v1r3p0   >> "%obuild_dir_project%\Versions"
ECHO package SoGLUT v1r1p0   >> "%obuild_dir_project%\Versions"
ECHO package HEPVis v6r15p3   >> "%obuild_dir_project%\Versions"
ECHO package osc_source 16.11.8   >> "%obuild_dir_project%\Versions"
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_12
ECHO foreign Qt 4.4.2   >> "%obuild_dir_project%\Versions"
:end_if_platform_12
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
ECHO foreign Python 2.5   >> "%obuild_dir_project%\Versions"
:end_if_platform_13
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_14
ECHO foreign SDL 1.2.11   >> "%obuild_dir_project%\Versions"
:end_if_platform_14
SET obuild_platform_result=
ECHO foreign curl 3   >> "%obuild_dir_project%\Versions"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_16
IF NOT EXIST "%SDL_home%\lib"  ECHO WARNING : Directory %SDL_home%\lib not found.  && GOTO end_if_release_17
IF NOT EXIST "%obuild_dir_project%\bin\." MKDIR "%obuild_dir_project%\bin\."
XCOPY /E /Q "%SDL_home%\lib"\SDL.dll "%obuild_dir_project%\bin\." 1> exe_error_0
@IF ERRORLEVEL 1 @TYPE exe_error_0 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_0
:end_if_release_17
:end_if_platform_16
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_18
IF NOT EXIST "%curl_home%"  ECHO WARNING : Directory %curl_home% not found.  && GOTO end_if_release_19
IF NOT EXIST "%obuild_dir_project%\bin\." MKDIR "%obuild_dir_project%\bin\."
XCOPY /E /Q "%curl_home%"\libcurl.dll "%obuild_dir_project%\bin\." 1> exe_error_1
@IF ERRORLEVEL 1 @TYPE exe_error_1 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_1
:end_if_release_19
:end_if_platform_18
SET obuild_platform_result=

IF NOT EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_iv_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_osc_iv_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_osc_iv_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r10p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

IF NOT EXIST "%obuild_foreign_path%\..\foreign"  ECHO WARNING : Directory %obuild_foreign_path%\..\foreign not found.  && GOTO end_if_release_21
IF NOT EXIST "%obuild_dir_project%\Resources\.\foreign" MKDIR "%obuild_dir_project%\Resources\.\foreign"
XCOPY /E /Q "%obuild_foreign_path%\..\foreign" "%obuild_dir_project%\Resources\.\foreign" 1> exe_error_2
@IF ERRORLEVEL 1 @TYPE exe_error_2 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_2
:end_if_release_21
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p6`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\include"  ECHO WARNING : Directory %obuild_CoinGL_path%\include not found.  && GOTO end_if_release_23
IF NOT EXIST "%obuild_dir_project%\Resources\CoinGL\.\include" MKDIR "%obuild_dir_project%\Resources\CoinGL\.\include"
XCOPY /E /Q "%obuild_CoinGL_path%\include" "%obuild_dir_project%\Resources\CoinGL\.\include" 1> exe_error_3
@IF ERRORLEVEL 1 @TYPE exe_error_3 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_3
:end_if_release_23
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\include"  ECHO WARNING : Directory %obuild_CoinGtk_path%\include not found.  && GOTO end_if_release_25
IF NOT EXIST "%obuild_dir_project%\Resources\CoinGtk\.\include" MKDIR "%obuild_dir_project%\Resources\CoinGtk\.\include"
XCOPY /E /Q "%obuild_CoinGtk_path%\include" "%obuild_dir_project%\Resources\CoinGtk\.\include" 1> exe_error_4
@IF ERRORLEVEL 1 @TYPE exe_error_4 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_4
:end_if_release_25
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\include"  ECHO WARNING : Directory %obuild_CoinWin_path%\include not found.  && GOTO end_if_release_27
IF NOT EXIST "%obuild_dir_project%\Resources\CoinWin\.\include" MKDIR "%obuild_dir_project%\Resources\CoinWin\.\include"
XCOPY /E /Q "%obuild_CoinWin_path%\include" "%obuild_dir_project%\Resources\CoinWin\.\include" 1> exe_error_5
@IF ERRORLEVEL 1 @TYPE exe_error_5 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_5
:end_if_release_27
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\include"  ECHO WARNING : Directory %obuild_CoinQt_path%\include not found.  && GOTO end_if_release_29
IF NOT EXIST "%obuild_dir_project%\Resources\CoinQt\.\include" MKDIR "%obuild_dir_project%\Resources\CoinQt\.\include"
XCOPY /E /Q "%obuild_CoinQt_path%\include" "%obuild_dir_project%\Resources\CoinQt\.\include" 1> exe_error_6
@IF ERRORLEVEL 1 @TYPE exe_error_6 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_6
:end_if_release_29
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\include"  ECHO WARNING : Directory %obuild_CoinXt_path%\include not found.  && GOTO end_if_release_31
IF NOT EXIST "%obuild_dir_project%\Resources\CoinXt\.\include" MKDIR "%obuild_dir_project%\Resources\CoinXt\.\include"
XCOPY /E /Q "%obuild_CoinXt_path%\include" "%obuild_dir_project%\Resources\CoinXt\.\include" 1> exe_error_7
@IF ERRORLEVEL 1 @TYPE exe_error_7 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_7
:end_if_release_31
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p12`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\scripts"  ECHO WARNING : Directory %obuild_CoinPython_path%\scripts not found.  && GOTO end_if_release_33
IF NOT EXIST "%obuild_dir_project%\Resources\CoinPython\.\scripts" MKDIR "%obuild_dir_project%\Resources\CoinPython\.\scripts"
XCOPY /E /Q "%obuild_CoinPython_path%\scripts" "%obuild_dir_project%\Resources\CoinPython\.\scripts" 1> exe_error_8
@IF ERRORLEVEL 1 @TYPE exe_error_8 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_8
:end_if_release_33
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\include"  ECHO WARNING : Directory %obuild_SoSDL_path%\include not found.  && GOTO end_if_release_35
IF NOT EXIST "%obuild_dir_project%\Resources\SoSDL\.\include" MKDIR "%obuild_dir_project%\Resources\SoSDL\.\include"
XCOPY /E /Q "%obuild_SoSDL_path%\include" "%obuild_dir_project%\Resources\SoSDL\.\include" 1> exe_error_9
@IF ERRORLEVEL 1 @TYPE exe_error_9 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_9
:end_if_release_35
IF NOT EXIST "%obuild_SoSDL_path%\data"  ECHO WARNING : Directory %obuild_SoSDL_path%\data not found.  && GOTO end_if_release_37
IF NOT EXIST "%obuild_dir_project%\Resources\SoSDL\.\data" MKDIR "%obuild_dir_project%\Resources\SoSDL\.\data"
XCOPY /E /Q "%obuild_SoSDL_path%\data" "%obuild_dir_project%\Resources\SoSDL\.\data" 1> exe_error_10
@IF ERRORLEVEL 1 @TYPE exe_error_10 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_10
:end_if_release_37
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoGLUT v1r1p0`) DO SET obuild_SoGLUT_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoGLUT_path  ECHO Can't find SoGLUT package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoGLUT_path%\include"  ECHO WARNING : Directory %obuild_SoGLUT_path%\include not found.  && GOTO end_if_release_39
IF NOT EXIST "%obuild_dir_project%\Resources\SoGLUT\.\include" MKDIR "%obuild_dir_project%\Resources\SoGLUT\.\include"
XCOPY /E /Q "%obuild_SoGLUT_path%\include" "%obuild_dir_project%\Resources\SoGLUT\.\include" 1> exe_error_11
@IF ERRORLEVEL 1 @TYPE exe_error_11 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_11
:end_if_release_39
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\scripts"  ECHO WARNING : Directory %obuild_HEPVis_path%\scripts not found.  && GOTO end_if_release_41
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\scripts" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\scripts"
XCOPY /E /Q "%obuild_HEPVis_path%\scripts" "%obuild_dir_project%\Resources\HEPVis\.\scripts" 1> exe_error_12
@IF ERRORLEVEL 1 @TYPE exe_error_12 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_12
:end_if_release_41
IF NOT EXIST "%obuild_HEPVis_path%\fonts"  ECHO WARNING : Directory %obuild_HEPVis_path%\fonts not found.  && GOTO end_if_release_43
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\fonts" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\fonts"
XCOPY /E /Q "%obuild_HEPVis_path%\fonts" "%obuild_dir_project%\Resources\HEPVis\.\fonts" 1> exe_error_13
@IF ERRORLEVEL 1 @TYPE exe_error_13 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_13
:end_if_release_43
IF NOT EXIST "%obuild_HEPVis_path%\include"  ECHO WARNING : Directory %obuild_HEPVis_path%\include not found.  && GOTO end_if_release_45
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\include" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\include"
XCOPY /E /Q "%obuild_HEPVis_path%\include" "%obuild_dir_project%\Resources\HEPVis\.\include" 1> exe_error_14
@IF ERRORLEVEL 1 @TYPE exe_error_14 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_14
:end_if_release_45
IF NOT EXIST "%obuild_HEPVis_path%\examples"  ECHO WARNING : Directory %obuild_HEPVis_path%\examples not found.  && GOTO end_if_release_47
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\examples" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\examples"
XCOPY /E /Q "%obuild_HEPVis_path%\examples" "%obuild_dir_project%\Resources\HEPVis\.\examples" 1> exe_error_15
@IF ERRORLEVEL 1 @TYPE exe_error_15 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_15
:end_if_release_47
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source 16.11.8`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

IF NOT EXIST "%obuild_osc_source_path%\release\License"  ECHO WARNING : File %obuild_osc_source_path%\release\License not found.  && GOTO end_if_release_49
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\License" "%obuild_dir_project%\." 1> exe_error_16
@IF ERRORLEVEL 1 @TYPE exe_error_16 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_16
:end_if_release_49
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_50
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\setup.bat not found.  && GOTO end_if_release_51
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\setup.bat" "%obuild_dir_project%\." 1> exe_error_17
@IF ERRORLEVEL 1 @TYPE exe_error_17 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_17
:end_if_release_51
:end_if_platform_50
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_52
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\aida-setup.bat not found.  && GOTO end_if_release_53
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat" "%obuild_dir_project%\." 1> exe_error_18
@IF ERRORLEVEL 1 @TYPE exe_error_18 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_18
:end_if_release_53
:end_if_platform_52
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_54
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\README"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\README not found.  && GOTO end_if_release_55
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\README" "%obuild_dir_project%\." 1> exe_error_19
@IF ERRORLEVEL 1 @TYPE exe_error_19 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_19
:end_if_release_55
:end_if_platform_54
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_56
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\check_install.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\check_install.bat not found.  && GOTO end_if_release_57
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\check_install.bat" "%obuild_dir_project%\." 1> exe_error_20
@IF ERRORLEVEL 1 @TYPE exe_error_20 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_20
:end_if_release_57
:end_if_platform_56
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_58
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Python-setup.bat not found.  && GOTO end_if_release_59
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat" "%obuild_dir_project%\." 1> exe_error_21
@IF ERRORLEVEL 1 @TYPE exe_error_21 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_21
:end_if_release_59
:end_if_platform_58
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_60
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat not found.  && GOTO end_if_release_61
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat" "%obuild_dir_project%\." 1> exe_error_22
@IF ERRORLEVEL 1 @TYPE exe_error_22 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_22
:end_if_release_61
:end_if_platform_60
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_62
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat not found.  && GOTO end_if_release_63
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat" "%obuild_dir_project%\." 1> exe_error_23
@IF ERRORLEVEL 1 @TYPE exe_error_23 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_23
:end_if_release_63
:end_if_platform_62
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_64
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\desktop"  ECHO WARNING : Directory %obuild_osc_source_path%\release\Windows_NT\desktop not found.  && GOTO end_if_release_65
IF NOT EXIST "%obuild_dir_project%\.\desktop" MKDIR "%obuild_dir_project%\.\desktop"
XCOPY /E /Q "%obuild_osc_source_path%\release\Windows_NT\desktop" "%obuild_dir_project%\.\desktop" 1> exe_error_24
@IF ERRORLEVEL 1 @TYPE exe_error_24 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_24
:end_if_release_65
:end_if_platform_64
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_66
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.arc" GOTO end_if_copy_25
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.arc" "%obuild_dir_project%\lib\." 1> exe_error_25
  @IF ERRORLEVEL 1 @TYPE exe_error_25 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_25
:end_if_copy_25
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" GOTO end_if_copy_26
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" "%obuild_dir_project%\lib\." 1> exe_error_26
  @IF ERRORLEVEL 1 @TYPE exe_error_26 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_26
:end_if_copy_26
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" GOTO end_if_copy_27
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" "%obuild_dir_project%\bin\." 1> exe_error_27
  @IF ERRORLEVEL 1 @TYPE exe_error_27 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_27
:end_if_copy_27
:end_if_release_66
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_67
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.arc" GOTO end_if_copy_28
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.arc" "%obuild_dir_project%\lib\." 1> exe_error_28
  @IF ERRORLEVEL 1 @TYPE exe_error_28 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_28
:end_if_copy_28
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" GOTO end_if_copy_29
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" "%obuild_dir_project%\lib\." 1> exe_error_29
  @IF ERRORLEVEL 1 @TYPE exe_error_29 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_29
:end_if_copy_29
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" GOTO end_if_copy_30
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" "%obuild_dir_project%\bin\." 1> exe_error_30
  @IF ERRORLEVEL 1 @TYPE exe_error_30 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_30
:end_if_copy_30
:end_if_release_67
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  png v1r1216p8`) DO SET obuild_png_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_png_path  ECHO Can't find png package.  && GOTO obuild_return

IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_png_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_68
IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%\osc_png.arc" GOTO end_if_copy_31
  COPY "%obuild_png_path%\%obuild_dir_bin%\osc_png.arc" "%obuild_dir_project%\lib\." 1> exe_error_31
  @IF ERRORLEVEL 1 @TYPE exe_error_31 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_31
:end_if_copy_31
IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%\osc_png.lib" GOTO end_if_copy_32
  COPY "%obuild_png_path%\%obuild_dir_bin%\osc_png.lib" "%obuild_dir_project%\lib\." 1> exe_error_32
  @IF ERRORLEVEL 1 @TYPE exe_error_32 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_32
:end_if_copy_32
IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%\osc_png.dll" GOTO end_if_copy_33
  COPY "%obuild_png_path%\%obuild_dir_bin%\osc_png.dll" "%obuild_dir_project%\bin\." 1> exe_error_33
  @IF ERRORLEVEL 1 @TYPE exe_error_33 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_33
:end_if_copy_33
:end_if_release_68
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  jpeg v1r62p8`) DO SET obuild_jpeg_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_jpeg_path  ECHO Can't find jpeg package.  && GOTO obuild_return

IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_jpeg_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_69
IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.arc" GOTO end_if_copy_34
  COPY "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.arc" "%obuild_dir_project%\lib\." 1> exe_error_34
  @IF ERRORLEVEL 1 @TYPE exe_error_34 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_34
:end_if_copy_34
IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.lib" GOTO end_if_copy_35
  COPY "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.lib" "%obuild_dir_project%\lib\." 1> exe_error_35
  @IF ERRORLEVEL 1 @TYPE exe_error_35 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_35
:end_if_copy_35
IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.dll" GOTO end_if_copy_36
  COPY "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.dll" "%obuild_dir_project%\bin\." 1> exe_error_36
  @IF ERRORLEVEL 1 @TYPE exe_error_36 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_36
:end_if_copy_36
:end_if_release_69
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p9`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_70
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.arc" GOTO end_if_copy_37
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.arc" "%obuild_dir_project%\lib\." 1> exe_error_37
  @IF ERRORLEVEL 1 @TYPE exe_error_37 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_37
:end_if_copy_37
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.lib" GOTO end_if_copy_38
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.lib" "%obuild_dir_project%\lib\." 1> exe_error_38
  @IF ERRORLEVEL 1 @TYPE exe_error_38 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_38
:end_if_copy_38
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.dll" GOTO end_if_copy_39
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.dll" "%obuild_dir_project%\bin\." 1> exe_error_39
  @IF ERRORLEVEL 1 @TYPE exe_error_39 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_39
:end_if_copy_39
:end_if_release_70
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  freetype2 v1r219p7`) DO SET obuild_freetype2_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_freetype2_path  ECHO Can't find freetype2 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_freetype2_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_71
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.arc" GOTO end_if_copy_40
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.arc" "%obuild_dir_project%\lib\." 1> exe_error_40
  @IF ERRORLEVEL 1 @TYPE exe_error_40 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_40
:end_if_copy_40
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.lib" GOTO end_if_copy_41
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.lib" "%obuild_dir_project%\lib\." 1> exe_error_41
  @IF ERRORLEVEL 1 @TYPE exe_error_41 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_41
:end_if_copy_41
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.dll" GOTO end_if_copy_42
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.dll" "%obuild_dir_project%\bin\." 1> exe_error_42
  @IF ERRORLEVEL 1 @TYPE exe_error_42 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_42
:end_if_copy_42
:end_if_release_71
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p6`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_72
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.arc" GOTO end_if_copy_43
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.arc" "%obuild_dir_project%\lib\." 1> exe_error_43
  @IF ERRORLEVEL 1 @TYPE exe_error_43 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_43
:end_if_copy_43
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.lib" GOTO end_if_copy_44
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.lib" "%obuild_dir_project%\lib\." 1> exe_error_44
  @IF ERRORLEVEL 1 @TYPE exe_error_44 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_44
:end_if_copy_44
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.dll" GOTO end_if_copy_45
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.dll" "%obuild_dir_project%\bin\." 1> exe_error_45
  @IF ERRORLEVEL 1 @TYPE exe_error_45 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_45
:end_if_copy_45
:end_if_release_72
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinNextStep v1r0p4`) DO SET obuild_CoinNextStep_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinNextStep_path  ECHO Can't find CoinNextStep package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%"  GOTO end_if_release_73
IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.arc" GOTO end_if_copy_46
  COPY "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.arc" "%obuild_dir_project%\lib\." 1> exe_error_46
  @IF ERRORLEVEL 1 @TYPE exe_error_46 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_46
:end_if_copy_46
IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.lib" GOTO end_if_copy_47
  COPY "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.lib" "%obuild_dir_project%\lib\." 1> exe_error_47
  @IF ERRORLEVEL 1 @TYPE exe_error_47 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_47
:end_if_copy_47
IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.dll" GOTO end_if_copy_48
  COPY "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep.dll" "%obuild_dir_project%\bin\." 1> exe_error_48
  @IF ERRORLEVEL 1 @TYPE exe_error_48 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_48
:end_if_copy_48
:end_if_release_73
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  gtkglarea v1r123p3`) DO SET obuild_gtkglarea_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_gtkglarea_path  ECHO Can't find gtkglarea package.  && GOTO obuild_return

IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%"  GOTO end_if_release_74
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.arc" GOTO end_if_copy_49
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.arc" "%obuild_dir_project%\lib\." 1> exe_error_49
  @IF ERRORLEVEL 1 @TYPE exe_error_49 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_49
:end_if_copy_49
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.lib" GOTO end_if_copy_50
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.lib" "%obuild_dir_project%\lib\." 1> exe_error_50
  @IF ERRORLEVEL 1 @TYPE exe_error_50 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_50
:end_if_copy_50
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.dll" GOTO end_if_copy_51
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\osc_gtkglarea.dll" "%obuild_dir_project%\bin\." 1> exe_error_51
  @IF ERRORLEVEL 1 @TYPE exe_error_51 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_51
:end_if_copy_51
:end_if_release_74
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_75
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.arc" GOTO end_if_copy_52
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.arc" "%obuild_dir_project%\lib\." 1> exe_error_52
  @IF ERRORLEVEL 1 @TYPE exe_error_52 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_52
:end_if_copy_52
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.lib" GOTO end_if_copy_53
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.lib" "%obuild_dir_project%\lib\." 1> exe_error_53
  @IF ERRORLEVEL 1 @TYPE exe_error_53 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_53
:end_if_copy_53
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.dll" GOTO end_if_copy_54
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.dll" "%obuild_dir_project%\bin\." 1> exe_error_54
  @IF ERRORLEVEL 1 @TYPE exe_error_54 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_54
:end_if_copy_54
:end_if_release_75
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  GOTO end_if_release_76
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.arc" GOTO end_if_copy_55
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.arc" "%obuild_dir_project%\lib\." 1> exe_error_55
  @IF ERRORLEVEL 1 @TYPE exe_error_55 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_55
:end_if_copy_55
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.lib" GOTO end_if_copy_56
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.lib" "%obuild_dir_project%\lib\." 1> exe_error_56
  @IF ERRORLEVEL 1 @TYPE exe_error_56 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_56
:end_if_copy_56
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.dll" GOTO end_if_copy_57
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.dll" "%obuild_dir_project%\bin\." 1> exe_error_57
  @IF ERRORLEVEL 1 @TYPE exe_error_57 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_57
:end_if_copy_57
:end_if_release_76
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_77
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.arc" GOTO end_if_copy_58
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.arc" "%obuild_dir_project%\lib\." 1> exe_error_58
  @IF ERRORLEVEL 1 @TYPE exe_error_58 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_58
:end_if_copy_58
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.lib" GOTO end_if_copy_59
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.lib" "%obuild_dir_project%\lib\." 1> exe_error_59
  @IF ERRORLEVEL 1 @TYPE exe_error_59 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_59
:end_if_copy_59
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.dll" GOTO end_if_copy_60
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.dll" "%obuild_dir_project%\bin\." 1> exe_error_60
  @IF ERRORLEVEL 1 @TYPE exe_error_60 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_60
:end_if_copy_60
:end_if_release_77
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_78
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.arc" GOTO end_if_copy_61
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.arc" "%obuild_dir_project%\lib\." 1> exe_error_61
  @IF ERRORLEVEL 1 @TYPE exe_error_61 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_61
:end_if_copy_61
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.lib" GOTO end_if_copy_62
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.lib" "%obuild_dir_project%\lib\." 1> exe_error_62
  @IF ERRORLEVEL 1 @TYPE exe_error_62 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_62
:end_if_copy_62
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.dll" GOTO end_if_copy_63
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt.dll" "%obuild_dir_project%\bin\." 1> exe_error_63
  @IF ERRORLEVEL 1 @TYPE exe_error_63 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_63
:end_if_copy_63
:end_if_release_78
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_79
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.arc" GOTO end_if_copy_64
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.arc" "%obuild_dir_project%\lib\." 1> exe_error_64
  @IF ERRORLEVEL 1 @TYPE exe_error_64 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_64
:end_if_copy_64
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.lib" GOTO end_if_copy_65
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.lib" "%obuild_dir_project%\lib\." 1> exe_error_65
  @IF ERRORLEVEL 1 @TYPE exe_error_65 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_65
:end_if_copy_65
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.dll" GOTO end_if_copy_66
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.dll" "%obuild_dir_project%\bin\." 1> exe_error_66
  @IF ERRORLEVEL 1 @TYPE exe_error_66 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_66
:end_if_copy_66
:end_if_release_79
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoGLUT v1r1p0`) DO SET obuild_SoGLUT_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoGLUT_path  ECHO Can't find SoGLUT package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%"  GOTO end_if_release_80
IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.arc" GOTO end_if_copy_67
  COPY "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.arc" "%obuild_dir_project%\lib\." 1> exe_error_67
  @IF ERRORLEVEL 1 @TYPE exe_error_67 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_67
:end_if_copy_67
IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.lib" GOTO end_if_copy_68
  COPY "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.lib" "%obuild_dir_project%\lib\." 1> exe_error_68
  @IF ERRORLEVEL 1 @TYPE exe_error_68 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_68
:end_if_copy_68
IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.dll" GOTO end_if_copy_69
  COPY "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT.dll" "%obuild_dir_project%\bin\." 1> exe_error_69
  @IF ERRORLEVEL 1 @TYPE exe_error_69 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_69
:end_if_copy_69
:end_if_release_80
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_81
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.arc" GOTO end_if_copy_70
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.arc" "%obuild_dir_project%\lib\." 1> exe_error_70
  @IF ERRORLEVEL 1 @TYPE exe_error_70 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_70
:end_if_copy_70
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.lib" GOTO end_if_copy_71
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.lib" "%obuild_dir_project%\lib\." 1> exe_error_71
  @IF ERRORLEVEL 1 @TYPE exe_error_71 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_71
:end_if_copy_71
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.dll" GOTO end_if_copy_72
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.dll" "%obuild_dir_project%\bin\." 1> exe_error_72
  @IF ERRORLEVEL 1 @TYPE exe_error_72 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_72
:end_if_copy_72
:end_if_release_81
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_82
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.arc" GOTO end_if_copy_73
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.arc" "%obuild_dir_project%\lib\." 1> exe_error_73
  @IF ERRORLEVEL 1 @TYPE exe_error_73 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_73
:end_if_copy_73
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.lib" GOTO end_if_copy_74
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.lib" "%obuild_dir_project%\lib\." 1> exe_error_74
  @IF ERRORLEVEL 1 @TYPE exe_error_74 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_74
:end_if_copy_74
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.dll" GOTO end_if_copy_75
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.dll" "%obuild_dir_project%\bin\." 1> exe_error_75
  @IF ERRORLEVEL 1 @TYPE exe_error_75 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_75
:end_if_copy_75
:end_if_release_82
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_83
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.arc" GOTO end_if_copy_76
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.arc" "%obuild_dir_project%\lib\." 1> exe_error_76
  @IF ERRORLEVEL 1 @TYPE exe_error_76 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_76
:end_if_copy_76
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.lib" GOTO end_if_copy_77
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.lib" "%obuild_dir_project%\lib\." 1> exe_error_77
  @IF ERRORLEVEL 1 @TYPE exe_error_77 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_77
:end_if_copy_77
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.dll" GOTO end_if_copy_78
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.dll" "%obuild_dir_project%\bin\." 1> exe_error_78
  @IF ERRORLEVEL 1 @TYPE exe_error_78 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_78
:end_if_copy_78
:end_if_release_83
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_84
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.arc" GOTO end_if_copy_79
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.arc" "%obuild_dir_project%\lib\." 1> exe_error_79
  @IF ERRORLEVEL 1 @TYPE exe_error_79 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_79
:end_if_copy_79
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.lib" GOTO end_if_copy_80
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.lib" "%obuild_dir_project%\lib\." 1> exe_error_80
  @IF ERRORLEVEL 1 @TYPE exe_error_80 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_80
:end_if_copy_80
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.dll" GOTO end_if_copy_81
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.dll" "%obuild_dir_project%\bin\." 1> exe_error_81
  @IF ERRORLEVEL 1 @TYPE exe_error_81 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_81
:end_if_copy_81
:end_if_release_84
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_85
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.arc" GOTO end_if_copy_82
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.arc" "%obuild_dir_project%\lib\." 1> exe_error_82
  @IF ERRORLEVEL 1 @TYPE exe_error_82 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_82
:end_if_copy_82
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.lib" GOTO end_if_copy_83
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.lib" "%obuild_dir_project%\lib\." 1> exe_error_83
  @IF ERRORLEVEL 1 @TYPE exe_error_83 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_83
:end_if_copy_83
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.dll" GOTO end_if_copy_84
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.dll" "%obuild_dir_project%\bin\." 1> exe_error_84
  @IF ERRORLEVEL 1 @TYPE exe_error_84 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_84
:end_if_copy_84
:end_if_release_85
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_86
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.arc" GOTO end_if_copy_85
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.arc" "%obuild_dir_project%\lib\." 1> exe_error_85
  @IF ERRORLEVEL 1 @TYPE exe_error_85 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_85
:end_if_copy_85
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.lib" GOTO end_if_copy_86
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.lib" "%obuild_dir_project%\lib\." 1> exe_error_86
  @IF ERRORLEVEL 1 @TYPE exe_error_86 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_86
:end_if_copy_86
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.dll" GOTO end_if_copy_87
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisXt.dll" "%obuild_dir_project%\bin\." 1> exe_error_87
  @IF ERRORLEVEL 1 @TYPE exe_error_87 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_87
:end_if_copy_87
:end_if_release_86
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_87
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.arc" GOTO end_if_copy_88
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.arc" "%obuild_dir_project%\lib\." 1> exe_error_88
  @IF ERRORLEVEL 1 @TYPE exe_error_88 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_88
:end_if_copy_88
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.lib" GOTO end_if_copy_89
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.lib" "%obuild_dir_project%\lib\." 1> exe_error_89
  @IF ERRORLEVEL 1 @TYPE exe_error_89 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_89
:end_if_copy_89
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.dll" GOTO end_if_copy_90
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.dll" "%obuild_dir_project%\bin\." 1> exe_error_90
  @IF ERRORLEVEL 1 @TYPE exe_error_90 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_90
:end_if_copy_90
:end_if_release_87
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_88
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.arc" GOTO end_if_copy_91
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.arc" "%obuild_dir_project%\lib\." 1> exe_error_91
  @IF ERRORLEVEL 1 @TYPE exe_error_91 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_91
:end_if_copy_91
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.lib" GOTO end_if_copy_92
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.lib" "%obuild_dir_project%\lib\." 1> exe_error_92
  @IF ERRORLEVEL 1 @TYPE exe_error_92 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_92
:end_if_copy_92
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.dll" GOTO end_if_copy_93
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.dll" "%obuild_dir_project%\bin\." 1> exe_error_93
  @IF ERRORLEVEL 1 @TYPE exe_error_93 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_93
:end_if_copy_93
:end_if_release_88
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_89
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.arc" GOTO end_if_copy_94
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.arc" "%obuild_dir_project%\lib\." 1> exe_error_94
  @IF ERRORLEVEL 1 @TYPE exe_error_94 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_94
:end_if_copy_94
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.lib" GOTO end_if_copy_95
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.lib" "%obuild_dir_project%\lib\." 1> exe_error_95
  @IF ERRORLEVEL 1 @TYPE exe_error_95 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_95
:end_if_copy_95
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.dll" GOTO end_if_copy_96
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.dll" "%obuild_dir_project%\bin\." 1> exe_error_96
  @IF ERRORLEVEL 1 @TYPE exe_error_96 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_96
:end_if_copy_96
:end_if_release_89
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_90
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.arc" GOTO end_if_copy_97
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.arc" "%obuild_dir_project%\lib\." 1> exe_error_97
  @IF ERRORLEVEL 1 @TYPE exe_error_97 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_97
:end_if_copy_97
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.lib" GOTO end_if_copy_98
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.lib" "%obuild_dir_project%\lib\." 1> exe_error_98
  @IF ERRORLEVEL 1 @TYPE exe_error_98 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_98
:end_if_copy_98
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.dll" GOTO end_if_copy_99
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.dll" "%obuild_dir_project%\bin\." 1> exe_error_99
  @IF ERRORLEVEL 1 @TYPE exe_error_99 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_99
:end_if_copy_99
:end_if_release_90
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_91
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.arc" GOTO end_if_copy_100
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.arc" "%obuild_dir_project%\lib\." 1> exe_error_100
  @IF ERRORLEVEL 1 @TYPE exe_error_100 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_100
:end_if_copy_100
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.lib" GOTO end_if_copy_101
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.lib" "%obuild_dir_project%\lib\." 1> exe_error_101
  @IF ERRORLEVEL 1 @TYPE exe_error_101 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_101
:end_if_copy_101
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.dll" GOTO end_if_copy_102
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGLUT.dll" "%obuild_dir_project%\bin\." 1> exe_error_102
  @IF ERRORLEVEL 1 @TYPE exe_error_102 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_102
:end_if_copy_102
:end_if_release_91

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p12`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%"  GOTO end_if_release_92
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.lib" GOTO end_if_copy_103
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.lib" "%obuild_dir_project%\lib\." 1> exe_error_103
  @IF ERRORLEVEL 1 @TYPE exe_error_103 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_103
:end_if_copy_103
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.dll" GOTO end_if_copy_104
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.dll" "%obuild_dir_project%\bin\." 1> exe_error_104
  @IF ERRORLEVEL 1 @TYPE exe_error_104 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_104
:end_if_copy_104
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\_CoinPython.pyd" GOTO end_if_copy_105
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\_CoinPython.pyd" "%obuild_dir_project%\bin\." 1> exe_error_105
  @IF ERRORLEVEL 1 @TYPE exe_error_105 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_105
:end_if_copy_105
:end_if_release_92
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_93
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisLoad.lib" GOTO end_if_copy_106
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisLoad.lib" "%obuild_dir_project%\lib\." 1> exe_error_106
  @IF ERRORLEVEL 1 @TYPE exe_error_106 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_106
:end_if_copy_106
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisLoad.dll" GOTO end_if_copy_107
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisLoad.dll" "%obuild_dir_project%\bin\." 1> exe_error_107
  @IF ERRORLEVEL 1 @TYPE exe_error_107 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_107
:end_if_copy_107
:end_if_release_93
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_94
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.lib" GOTO end_if_copy_108
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.lib" "%obuild_dir_project%\lib\." 1> exe_error_108
  @IF ERRORLEVEL 1 @TYPE exe_error_108 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_108
:end_if_copy_108
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.dll" GOTO end_if_copy_109
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.dll" "%obuild_dir_project%\bin\." 1> exe_error_109
  @IF ERRORLEVEL 1 @TYPE exe_error_109 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_109
:end_if_copy_109
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.pyd" GOTO end_if_copy_110
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.pyd" "%obuild_dir_project%\bin\." 1> exe_error_110
  @IF ERRORLEVEL 1 @TYPE exe_error_110 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_110
:end_if_copy_110
:end_if_release_94

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_95
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" GOTO end_if_copy_111
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" "%obuild_dir_project%\bin\." 1> exe_error_111
  @IF ERRORLEVEL 1 @TYPE exe_error_111 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_111
:end_if_copy_111
:end_if_release_95
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_96
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" GOTO end_if_copy_112
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" "%obuild_dir_project%\bin\." 1> exe_error_112
  @IF ERRORLEVEL 1 @TYPE exe_error_112 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_112
:end_if_copy_112
:end_if_release_96
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_97
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" GOTO end_if_copy_113
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" "%obuild_dir_project%\bin\." 1> exe_error_113
  @IF ERRORLEVEL 1 @TYPE exe_error_113 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_113
:end_if_copy_113
:end_if_release_97
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_98
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" GOTO end_if_copy_114
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" "%obuild_dir_project%\bin\." 1> exe_error_114
  @IF ERRORLEVEL 1 @TYPE exe_error_114 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_114
:end_if_copy_114
:end_if_release_98
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_99
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" GOTO end_if_copy_115
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" "%obuild_dir_project%\bin\." 1> exe_error_115
  @IF ERRORLEVEL 1 @TYPE exe_error_115 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_115
:end_if_copy_115
:end_if_release_99
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_100
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" GOTO end_if_copy_116
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" "%obuild_dir_project%\bin\." 1> exe_error_116
  @IF ERRORLEVEL 1 @TYPE exe_error_116 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_116
:end_if_copy_116
:end_if_release_100
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p9`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_101
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvireport.exe" GOTO end_if_copy_117
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvireport.exe" "%obuild_dir_project%\bin\." 1> exe_error_117
  @IF ERRORLEVEL 1 @TYPE exe_error_117 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_117
:end_if_copy_117
:end_if_release_101
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p9`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_102
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvi2bitmap.exe" GOTO end_if_copy_118
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvi2bitmap.exe" "%obuild_dir_project%\bin\." 1> exe_error_118
  @IF ERRORLEVEL 1 @TYPE exe_error_118 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_118
:end_if_copy_118
:end_if_release_102
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p9`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_103
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\fontGeneration.exe" GOTO end_if_copy_119
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\fontGeneration.exe" "%obuild_dir_project%\bin\." 1> exe_error_119
  @IF ERRORLEVEL 1 @TYPE exe_error_119 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_119
:end_if_copy_119
:end_if_release_103
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  freetype2 v1r219p7`) DO SET obuild_freetype2_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_freetype2_path  ECHO Can't find freetype2 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_freetype2_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_104
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\freetypes_test_gb_0.exe" GOTO end_if_copy_120
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\freetypes_test_gb_0.exe" "%obuild_dir_project%\bin\." 1> exe_error_120
  @IF ERRORLEVEL 1 @TYPE exe_error_120 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_120
:end_if_copy_120
:end_if_release_104
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p6`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_105
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_coin_config.exe" GOTO end_if_copy_121
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_coin_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_121
  @IF ERRORLEVEL 1 @TYPE exe_error_121 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_121
:end_if_copy_121
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc-coin-gl-config.exe" GOTO end_if_copy_122
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc-coin-gl-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_122
  @IF ERRORLEVEL 1 @TYPE exe_error_122 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_122
:end_if_copy_122
:end_if_release_105
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p6`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_106
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.exe" GOTO end_if_copy_123
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_123
  @IF ERRORLEVEL 1 @TYPE exe_error_123 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_123
:end_if_copy_123
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.save" GOTO end_if_copy_124
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_124
  @IF ERRORLEVEL 1 @TYPE exe_error_124 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_124
:end_if_copy_124
:end_if_release_106
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinNextStep v1r0p4`) DO SET obuild_CoinNextStep_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinNextStep_path  ECHO Can't find CoinNextStep package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%"  GOTO end_if_release_107
IF NOT EXIST "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep_test_cube.exe" GOTO end_if_copy_125
  COPY "%obuild_CoinNextStep_path%\%obuild_dir_bin%\CoinNextStep_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_125
  @IF ERRORLEVEL 1 @TYPE exe_error_125 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_125
:end_if_copy_125
:end_if_release_107
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  gtkglarea v1r123p3`) DO SET obuild_gtkglarea_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_gtkglarea_path  ECHO Can't find gtkglarea package.  && GOTO obuild_return

IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%"  GOTO end_if_release_108
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_cube.exe" GOTO end_if_copy_126
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_126
  @IF ERRORLEVEL 1 @TYPE exe_error_126 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_126
:end_if_copy_126
:end_if_release_108
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  gtkglarea v1r123p3`) DO SET obuild_gtkglarea_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_gtkglarea_path  ECHO Can't find gtkglarea package.  && GOTO obuild_return

IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%"  GOTO end_if_release_109
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_simple.exe" GOTO end_if_copy_127
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_simple.exe" "%obuild_dir_project%\bin\." 1> exe_error_127
  @IF ERRORLEVEL 1 @TYPE exe_error_127 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_127
:end_if_copy_127
:end_if_release_109
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  gtkglarea v1r123p3`) DO SET obuild_gtkglarea_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_gtkglarea_path  ECHO Can't find gtkglarea package.  && GOTO obuild_return

IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%"  GOTO end_if_release_110
IF NOT EXIST "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_zktor.exe" GOTO end_if_copy_128
  COPY "%obuild_gtkglarea_path%\%obuild_dir_bin%\gtkglarea_zktor.exe" "%obuild_dir_project%\bin\." 1> exe_error_128
  @IF ERRORLEVEL 1 @TYPE exe_error_128 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_128
:end_if_copy_128
:end_if_release_110
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_111
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_glarea.exe" GOTO end_if_copy_129
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_glarea.exe" "%obuild_dir_project%\bin\." 1> exe_error_129
  @IF ERRORLEVEL 1 @TYPE exe_error_129 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_129
:end_if_copy_129
:end_if_release_111
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_112
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_cube.exe" GOTO end_if_copy_130
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_130
  @IF ERRORLEVEL 1 @TYPE exe_error_130 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_130
:end_if_copy_130
:end_if_release_112
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_113
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_gui.exe" GOTO end_if_copy_131
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_gui.exe" "%obuild_dir_project%\bin\." 1> exe_error_131
  @IF ERRORLEVEL 1 @TYPE exe_error_131 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_131
:end_if_copy_131
:end_if_release_113
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_114
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_coin_config.exe" GOTO end_if_copy_132
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_coin_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_132
  @IF ERRORLEVEL 1 @TYPE exe_error_132 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_132
:end_if_copy_132
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\osc-coin-gtk-config.exe" GOTO end_if_copy_133
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\osc-coin-gtk-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_133
  @IF ERRORLEVEL 1 @TYPE exe_error_133 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_133
:end_if_copy_133
:end_if_release_114
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p10`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  GOTO end_if_release_115
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.exe" GOTO end_if_copy_134
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_134
  @IF ERRORLEVEL 1 @TYPE exe_error_134 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_134
:end_if_copy_134
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.save" GOTO end_if_copy_135
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_135
  @IF ERRORLEVEL 1 @TYPE exe_error_135 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_135
:end_if_copy_135
:end_if_release_115
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  GOTO end_if_release_116
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_coin_config.exe" GOTO end_if_copy_136
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_coin_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_136
  @IF ERRORLEVEL 1 @TYPE exe_error_136 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_136
:end_if_copy_136
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\osc-coin-win-config.exe" GOTO end_if_copy_137
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\osc-coin-win-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_137
  @IF ERRORLEVEL 1 @TYPE exe_error_137 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_137
:end_if_copy_137
:end_if_release_116
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  GOTO end_if_release_117
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_config_save.exe" GOTO end_if_copy_138
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_138
  @IF ERRORLEVEL 1 @TYPE exe_error_138 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_138
:end_if_copy_138
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_config_save.save" GOTO end_if_copy_139
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_139
  @IF ERRORLEVEL 1 @TYPE exe_error_139 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_139
:end_if_copy_139
:end_if_release_117
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  GOTO end_if_release_118
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube.exe" GOTO end_if_copy_140
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_140
  @IF ERRORLEVEL 1 @TYPE exe_error_140 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_140
:end_if_copy_140
:end_if_release_118
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p14`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  GOTO end_if_release_119
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube2.exe" GOTO end_if_copy_141
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube2.exe" "%obuild_dir_project%\bin\." 1> exe_error_141
  @IF ERRORLEVEL 1 @TYPE exe_error_141 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_141
:end_if_copy_141
:end_if_release_119
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_120
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_cube.exe" GOTO end_if_copy_142
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_142
  @IF ERRORLEVEL 1 @TYPE exe_error_142 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_142
:end_if_copy_142
:end_if_release_120
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_121
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_gui.exe" GOTO end_if_copy_143
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_gui.exe" "%obuild_dir_project%\bin\." 1> exe_error_143
  @IF ERRORLEVEL 1 @TYPE exe_error_143 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_143
:end_if_copy_143
:end_if_release_121
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_122
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_GL.exe" GOTO end_if_copy_144
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_GL.exe" "%obuild_dir_project%\bin\." 1> exe_error_144
  @IF ERRORLEVEL 1 @TYPE exe_error_144 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_144
:end_if_copy_144
:end_if_release_122
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_123
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_coin_config.exe" GOTO end_if_copy_145
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_coin_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_145
  @IF ERRORLEVEL 1 @TYPE exe_error_145 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_145
:end_if_copy_145
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\osc-coin-qt-config.exe" GOTO end_if_copy_146
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\osc-coin-qt-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_146
  @IF ERRORLEVEL 1 @TYPE exe_error_146 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_146
:end_if_copy_146
:end_if_release_123
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p8`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  GOTO end_if_release_124
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.exe" GOTO end_if_copy_147
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_147
  @IF ERRORLEVEL 1 @TYPE exe_error_147 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_147
:end_if_copy_147
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.save" GOTO end_if_copy_148
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_148
  @IF ERRORLEVEL 1 @TYPE exe_error_148 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_148
:end_if_copy_148
:end_if_release_124
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_125
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_GL.exe" GOTO end_if_copy_149
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_GL.exe" "%obuild_dir_project%\bin\." 1> exe_error_149
  @IF ERRORLEVEL 1 @TYPE exe_error_149 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_149
:end_if_copy_149
:end_if_release_125
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_126
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_cube.exe" GOTO end_if_copy_150
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_150
  @IF ERRORLEVEL 1 @TYPE exe_error_150 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_150
:end_if_copy_150
:end_if_release_126
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_127
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_gui.exe" GOTO end_if_copy_151
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_gui.exe" "%obuild_dir_project%\bin\." 1> exe_error_151
  @IF ERRORLEVEL 1 @TYPE exe_error_151 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_151
:end_if_copy_151
:end_if_release_127
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_128
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_sceneViewer.exe" GOTO end_if_copy_152
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_test_sceneViewer.exe" "%obuild_dir_project%\bin\." 1> exe_error_152
  @IF ERRORLEVEL 1 @TYPE exe_error_152 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_152
:end_if_copy_152
:end_if_release_128
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_129
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_coin_config.exe" GOTO end_if_copy_153
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_coin_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_153
  @IF ERRORLEVEL 1 @TYPE exe_error_153 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_153
:end_if_copy_153
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\osc-coin-xt-config.exe" GOTO end_if_copy_154
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\osc-coin-xt-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_154
  @IF ERRORLEVEL 1 @TYPE exe_error_154 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_154
:end_if_copy_154
:end_if_release_129
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p9`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%"  GOTO end_if_release_130
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_config_save.exe" GOTO end_if_copy_155
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_155
  @IF ERRORLEVEL 1 @TYPE exe_error_155 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_155
:end_if_copy_155
IF NOT EXIST "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_config_save.save" GOTO end_if_copy_156
  COPY "%obuild_CoinXt_path%\%obuild_dir_bin%\CoinXt_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_156
  @IF ERRORLEVEL 1 @TYPE exe_error_156 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_156
:end_if_copy_156
:end_if_release_130
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p12`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%"  GOTO end_if_release_131
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython_exa_0.exe" GOTO end_if_copy_157
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython_exa_0.exe" "%obuild_dir_project%\bin\." 1> exe_error_157
  @IF ERRORLEVEL 1 @TYPE exe_error_157 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_157
:end_if_copy_157
:end_if_release_131
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_132
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube.exe" GOTO end_if_copy_158
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_158
  @IF ERRORLEVEL 1 @TYPE exe_error_158 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_158
:end_if_copy_158
:end_if_release_132
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_133
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_web.exe" GOTO end_if_copy_159
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_web.exe" "%obuild_dir_project%\bin\." 1> exe_error_159
  @IF ERRORLEVEL 1 @TYPE exe_error_159 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_159
:end_if_copy_159
:end_if_release_133
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_134
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SDL_query_video.exe" GOTO end_if_copy_160
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SDL_query_video.exe" "%obuild_dir_project%\bin\." 1> exe_error_160
  @IF ERRORLEVEL 1 @TYPE exe_error_160 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_160
:end_if_copy_160
:end_if_release_134
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_135
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_WILD.exe" GOTO end_if_copy_161
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_WILD.exe" "%obuild_dir_project%\bin\." 1> exe_error_161
  @IF ERRORLEVEL 1 @TYPE exe_error_161 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_161
:end_if_copy_161
:end_if_release_135
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_136
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube_WILD.exe" GOTO end_if_copy_162
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube_WILD.exe" "%obuild_dir_project%\bin\." 1> exe_error_162
  @IF ERRORLEVEL 1 @TYPE exe_error_162 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_162
:end_if_copy_162
:end_if_release_136
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r3p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  GOTO end_if_release_137
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_web_WILD.exe" GOTO end_if_copy_163
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_web_WILD.exe" "%obuild_dir_project%\bin\." 1> exe_error_163
  @IF ERRORLEVEL 1 @TYPE exe_error_163 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_163
:end_if_copy_163
:end_if_release_137
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoGLUT v1r1p0`) DO SET obuild_SoGLUT_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_SoGLUT_path  ECHO Can't find SoGLUT package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%"  GOTO end_if_release_138
IF NOT EXIST "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT_test_cube.exe" GOTO end_if_copy_164
  COPY "%obuild_SoGLUT_path%\%obuild_dir_bin%\SoGLUT_test_cube.exe" "%obuild_dir_project%\bin\." 1> exe_error_164
  @IF ERRORLEVEL 1 @TYPE exe_error_164 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_164
:end_if_copy_164
:end_if_release_138
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_139
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config.exe" GOTO end_if_copy_165
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_165
  @IF ERRORLEVEL 1 @TYPE exe_error_165 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_165
:end_if_copy_165
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\hepvis-config.exe" GOTO end_if_copy_166
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\hepvis-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_166
  @IF ERRORLEVEL 1 @TYPE exe_error_166 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_166
:end_if_copy_166
:end_if_release_139
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_140
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config_save.exe" GOTO end_if_copy_167
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config_save.exe" "%obuild_dir_project%\bin\." 1> exe_error_167
  @IF ERRORLEVEL 1 @TYPE exe_error_167 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_167
:end_if_copy_167
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config_save.save" GOTO end_if_copy_168
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_config_save.save" "%obuild_dir_project%\bin\." 1> exe_error_168
  @IF ERRORLEVEL 1 @TYPE exe_error_168 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_168
:end_if_copy_168
:end_if_release_140
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_141
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_coin.exe" GOTO end_if_copy_169
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_coin.exe" "%obuild_dir_project%\bin\." 1> exe_error_169
  @IF ERRORLEVEL 1 @TYPE exe_error_169 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_169
:end_if_copy_169
:end_if_release_141
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_142
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_freetype.exe" GOTO end_if_copy_170
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_freetype.exe" "%obuild_dir_project%\bin\." 1> exe_error_170
  @IF ERRORLEVEL 1 @TYPE exe_error_170 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_170
:end_if_copy_170
:end_if_release_142
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_143
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisToStdIv.exe" GOTO end_if_copy_171
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisToStdIv.exe" "%obuild_dir_project%\bin\." 1> exe_error_171
  @IF ERRORLEVEL 1 @TYPE exe_error_171 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_171
:end_if_copy_171
:end_if_release_143
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_144
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_convert.exe" GOTO end_if_copy_172
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_convert.exe" "%obuild_dir_project%\bin\." 1> exe_error_172
  @IF ERRORLEVEL 1 @TYPE exe_error_172 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_172
:end_if_copy_172
:end_if_release_144
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_145
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_iv2pov.exe" GOTO end_if_copy_173
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_iv2pov.exe" "%obuild_dir_project%\bin\." 1> exe_error_173
  @IF ERRORLEVEL 1 @TYPE exe_error_173 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_173
:end_if_copy_173
:end_if_release_145
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_146
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_hiv2pov.exe" GOTO end_if_copy_174
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_hiv2pov.exe" "%obuild_dir_project%\bin\." 1> exe_error_174
  @IF ERRORLEVEL 1 @TYPE exe_error_174 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_174
:end_if_copy_174
:end_if_release_146
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_147
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_gluTess.exe" GOTO end_if_copy_175
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_gluTess.exe" "%obuild_dir_project%\bin\." 1> exe_error_175
  @IF ERRORLEVEL 1 @TYPE exe_error_175 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_175
:end_if_copy_175
:end_if_release_147
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_148
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Dragger_Xt.exe" GOTO end_if_copy_176
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Dragger_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_176
  @IF ERRORLEVEL 1 @TYPE exe_error_176 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_176
:end_if_copy_176
:end_if_release_148
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_149
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_EditPolygon_Xt.exe" GOTO end_if_copy_177
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_EditPolygon_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_177
  @IF ERRORLEVEL 1 @TYPE exe_error_177 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_177
:end_if_copy_177
:end_if_release_149
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_150
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Manip_Xt.exe" GOTO end_if_copy_178
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Manip_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_178
  @IF ERRORLEVEL 1 @TYPE exe_error_178 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_178
:end_if_copy_178
:end_if_release_150
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_151
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Xt.exe" GOTO end_if_copy_179
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_179
  @IF ERRORLEVEL 1 @TYPE exe_error_179 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_179
:end_if_copy_179
:end_if_release_151
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_152
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Xt.exe" GOTO end_if_copy_180
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_180
  @IF ERRORLEVEL 1 @TYPE exe_error_180 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_180
:end_if_copy_180
:end_if_release_152
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_153
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Xt.exe" GOTO end_if_copy_181
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_181
  @IF ERRORLEVEL 1 @TYPE exe_error_181 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_181
:end_if_copy_181
:end_if_release_153
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_154
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Xt.exe" GOTO end_if_copy_182
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_182
  @IF ERRORLEVEL 1 @TYPE exe_error_182 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_182
:end_if_copy_182
:end_if_release_154
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_155
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Xt.exe" GOTO end_if_copy_183
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_183
  @IF ERRORLEVEL 1 @TYPE exe_error_183 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_183
:end_if_copy_183
:end_if_release_155
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_156
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Xt.exe" GOTO end_if_copy_184
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_184
  @IF ERRORLEVEL 1 @TYPE exe_error_184 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_184
:end_if_copy_184
:end_if_release_156
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_157
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Xt.exe" GOTO end_if_copy_185
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_185
  @IF ERRORLEVEL 1 @TYPE exe_error_185 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_185
:end_if_copy_185
:end_if_release_157
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_158
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Xt.exe" GOTO end_if_copy_186
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_186
  @IF ERRORLEVEL 1 @TYPE exe_error_186 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_186
:end_if_copy_186
:end_if_release_158
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_159
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Xt.exe" GOTO end_if_copy_187
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_187
  @IF ERRORLEVEL 1 @TYPE exe_error_187 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_187
:end_if_copy_187
:end_if_release_159
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_160
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Xt.exe" GOTO end_if_copy_188
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_188
  @IF ERRORLEVEL 1 @TYPE exe_error_188 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_188
:end_if_copy_188
:end_if_release_160
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_161
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Xt.exe" GOTO end_if_copy_189
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_189
  @IF ERRORLEVEL 1 @TYPE exe_error_189 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_189
:end_if_copy_189
:end_if_release_161
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_162
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Xt.exe" GOTO end_if_copy_190
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_190
  @IF ERRORLEVEL 1 @TYPE exe_error_190 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_190
:end_if_copy_190
:end_if_release_162
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_163
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Xt.exe" GOTO end_if_copy_191
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_191
  @IF ERRORLEVEL 1 @TYPE exe_error_191 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_191
:end_if_copy_191
:end_if_release_163
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_164
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Xt.exe" GOTO end_if_copy_192
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_192
  @IF ERRORLEVEL 1 @TYPE exe_error_192 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_192
:end_if_copy_192
:end_if_release_164
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_165
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Xt.exe" GOTO end_if_copy_193
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_193
  @IF ERRORLEVEL 1 @TYPE exe_error_193 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_193
:end_if_copy_193
:end_if_release_165
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_166
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Xt.exe" GOTO end_if_copy_194
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_194
  @IF ERRORLEVEL 1 @TYPE exe_error_194 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_194
:end_if_copy_194
:end_if_release_166
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_167
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Xt.exe" GOTO end_if_copy_195
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_195
  @IF ERRORLEVEL 1 @TYPE exe_error_195 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_195
:end_if_copy_195
:end_if_release_167
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_168
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Xt.exe" GOTO end_if_copy_196
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_196
  @IF ERRORLEVEL 1 @TYPE exe_error_196 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_196
:end_if_copy_196
:end_if_release_168
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_169
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Xt.exe" GOTO end_if_copy_197
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_197
  @IF ERRORLEVEL 1 @TYPE exe_error_197 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_197
:end_if_copy_197
:end_if_release_169
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_170
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Xt.exe" GOTO end_if_copy_198
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_198
  @IF ERRORLEVEL 1 @TYPE exe_error_198 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_198
:end_if_copy_198
:end_if_release_170
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_171
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestVRML_Xt.exe" GOTO end_if_copy_199
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestVRML_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_199
  @IF ERRORLEVEL 1 @TYPE exe_error_199 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_199
:end_if_copy_199
:end_if_release_171
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_172
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestKit_Xt.exe" GOTO end_if_copy_200
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_200
  @IF ERRORLEVEL 1 @TYPE exe_error_200 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_200
:end_if_copy_200
:end_if_release_172
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_173
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Triangles_Xt.exe" GOTO end_if_copy_201
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Triangles_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_201
  @IF ERRORLEVEL 1 @TYPE exe_error_201 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_201
:end_if_copy_201
:end_if_release_173
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_174
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Xt.exe" GOTO end_if_copy_202
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_202
  @IF ERRORLEVEL 1 @TYPE exe_error_202 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_202
:end_if_copy_202
:end_if_release_174
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_175
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Xt.exe" GOTO end_if_copy_203
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_203
  @IF ERRORLEVEL 1 @TYPE exe_error_203 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_203
:end_if_copy_203
:end_if_release_175
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_176
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Xt.exe" GOTO end_if_copy_204
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_204
  @IF ERRORLEVEL 1 @TYPE exe_error_204 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_204
:end_if_copy_204
:end_if_release_176
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_177
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Xt.exe" GOTO end_if_copy_205
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_205
  @IF ERRORLEVEL 1 @TYPE exe_error_205 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_205
:end_if_copy_205
:end_if_release_177
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_178
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Xt.exe" GOTO end_if_copy_206
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_206
  @IF ERRORLEVEL 1 @TYPE exe_error_206 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_206
:end_if_copy_206
:end_if_release_178
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_179
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Xt.exe" GOTO end_if_copy_207
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_207
  @IF ERRORLEVEL 1 @TYPE exe_error_207 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_207
:end_if_copy_207
:end_if_release_179
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_180
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Xt.exe" GOTO end_if_copy_208
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_208
  @IF ERRORLEVEL 1 @TYPE exe_error_208 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_208
:end_if_copy_208
:end_if_release_180
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_181
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Xt.exe" GOTO end_if_copy_209
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_209
  @IF ERRORLEVEL 1 @TYPE exe_error_209 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_209
:end_if_copy_209
:end_if_release_181
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_182
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Xt.exe" GOTO end_if_copy_210
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_210
  @IF ERRORLEVEL 1 @TYPE exe_error_210 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_210
:end_if_copy_210
:end_if_release_182
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_183
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Xt.exe" GOTO end_if_copy_211
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_211
  @IF ERRORLEVEL 1 @TYPE exe_error_211 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_211
:end_if_copy_211
:end_if_release_183
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_184
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Xt.exe" GOTO end_if_copy_212
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_212
  @IF ERRORLEVEL 1 @TYPE exe_error_212 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_212
:end_if_copy_212
:end_if_release_184
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_185
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Xt.exe" GOTO end_if_copy_213
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_213
  @IF ERRORLEVEL 1 @TYPE exe_error_213 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_213
:end_if_copy_213
:end_if_release_185
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_186
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Xt.exe" GOTO end_if_copy_214
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_214
  @IF ERRORLEVEL 1 @TYPE exe_error_214 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_214
:end_if_copy_214
:end_if_release_186
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_187
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Xt.exe" GOTO end_if_copy_215
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_215
  @IF ERRORLEVEL 1 @TYPE exe_error_215 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_215
:end_if_copy_215
:end_if_release_187
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_188
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Xt.exe" GOTO end_if_copy_216
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_216
  @IF ERRORLEVEL 1 @TYPE exe_error_216 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_216
:end_if_copy_216
:end_if_release_188
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_189
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Xt.exe" GOTO end_if_copy_217
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_217
  @IF ERRORLEVEL 1 @TYPE exe_error_217 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_217
:end_if_copy_217
:end_if_release_189
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_190
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Xt.exe" GOTO end_if_copy_218
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_218
  @IF ERRORLEVEL 1 @TYPE exe_error_218 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_218
:end_if_copy_218
:end_if_release_190
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_191
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Xt.exe" GOTO end_if_copy_219
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_219
  @IF ERRORLEVEL 1 @TYPE exe_error_219 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_219
:end_if_copy_219
:end_if_release_191
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_192
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Xt.exe" GOTO end_if_copy_220
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_220
  @IF ERRORLEVEL 1 @TYPE exe_error_220 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_220
:end_if_copy_220
:end_if_release_192
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_193
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Xt.exe" GOTO end_if_copy_221
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_221
  @IF ERRORLEVEL 1 @TYPE exe_error_221 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_221
:end_if_copy_221
:end_if_release_193
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_194
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Xt.exe" GOTO end_if_copy_222
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_222
  @IF ERRORLEVEL 1 @TYPE exe_error_222 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_222
:end_if_copy_222
:end_if_release_194
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_195
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Xt.exe" GOTO end_if_copy_223
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_223
  @IF ERRORLEVEL 1 @TYPE exe_error_223 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_223
:end_if_copy_223
:end_if_release_195
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_196
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Xt.exe" GOTO end_if_copy_224
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_224
  @IF ERRORLEVEL 1 @TYPE exe_error_224 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_224
:end_if_copy_224
:end_if_release_196
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_197
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Xt.exe" GOTO end_if_copy_225
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_225
  @IF ERRORLEVEL 1 @TYPE exe_error_225 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_225
:end_if_copy_225
:end_if_release_197
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_198
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Xt.exe" GOTO end_if_copy_226
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_226
  @IF ERRORLEVEL 1 @TYPE exe_error_226 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_226
:end_if_copy_226
:end_if_release_198
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_199
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Xt.exe" GOTO end_if_copy_227
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_227
  @IF ERRORLEVEL 1 @TYPE exe_error_227 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_227
:end_if_copy_227
:end_if_release_199
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_200
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Xt.exe" GOTO end_if_copy_228
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_228
  @IF ERRORLEVEL 1 @TYPE exe_error_228 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_228
:end_if_copy_228
:end_if_release_200
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_201
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Xt.exe" GOTO end_if_copy_229
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_229
  @IF ERRORLEVEL 1 @TYPE exe_error_229 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_229
:end_if_copy_229
:end_if_release_201
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_202
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Xt.exe" GOTO end_if_copy_230
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_230
  @IF ERRORLEVEL 1 @TYPE exe_error_230 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_230
:end_if_copy_230
:end_if_release_202
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_203
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Xt.exe" GOTO end_if_copy_231
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_231
  @IF ERRORLEVEL 1 @TYPE exe_error_231 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_231
:end_if_copy_231
:end_if_release_203
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_204
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_InfosRegion_Xt.exe" GOTO end_if_copy_232
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_InfosRegion_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_232
  @IF ERRORLEVEL 1 @TYPE exe_error_232 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_232
:end_if_copy_232
:end_if_release_204
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_205
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Xt.exe" GOTO end_if_copy_233
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_233
  @IF ERRORLEVEL 1 @TYPE exe_error_233 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_233
:end_if_copy_233
:end_if_release_205
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_206
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Xt.exe" GOTO end_if_copy_234
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_234
  @IF ERRORLEVEL 1 @TYPE exe_error_234 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_234
:end_if_copy_234
:end_if_release_206
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_207
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Xt.exe" GOTO end_if_copy_235
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_235
  @IF ERRORLEVEL 1 @TYPE exe_error_235 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_235
:end_if_copy_235
:end_if_release_207
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_208
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Xt.exe" GOTO end_if_copy_236
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_236
  @IF ERRORLEVEL 1 @TYPE exe_error_236 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_236
:end_if_copy_236
:end_if_release_208
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_209
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Xt.exe" GOTO end_if_copy_237
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_237
  @IF ERRORLEVEL 1 @TYPE exe_error_237 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_237
:end_if_copy_237
:end_if_release_209
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_210
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Xt.exe" GOTO end_if_copy_238
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_238
  @IF ERRORLEVEL 1 @TYPE exe_error_238 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_238
:end_if_copy_238
:end_if_release_210
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_211
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Xt.exe" GOTO end_if_copy_239
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_239
  @IF ERRORLEVEL 1 @TYPE exe_error_239 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_239
:end_if_copy_239
:end_if_release_211
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_212
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Xt.exe" GOTO end_if_copy_240
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_240
  @IF ERRORLEVEL 1 @TYPE exe_error_240 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_240
:end_if_copy_240
:end_if_release_212
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_213
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Xt.exe" GOTO end_if_copy_241
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_241
  @IF ERRORLEVEL 1 @TYPE exe_error_241 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_241
:end_if_copy_241
:end_if_release_213
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_214
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Xt.exe" GOTO end_if_copy_242
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_242
  @IF ERRORLEVEL 1 @TYPE exe_error_242 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_242
:end_if_copy_242
:end_if_release_214
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_215
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Xt.exe" GOTO end_if_copy_243
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_243
  @IF ERRORLEVEL 1 @TYPE exe_error_243 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_243
:end_if_copy_243
:end_if_release_215
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_216
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Xt.exe" GOTO end_if_copy_244
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_244
  @IF ERRORLEVEL 1 @TYPE exe_error_244 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_244
:end_if_copy_244
:end_if_release_216
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_217
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Xt.exe" GOTO end_if_copy_245
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_245
  @IF ERRORLEVEL 1 @TYPE exe_error_245 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_245
:end_if_copy_245
:end_if_release_217
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_218
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Xt.exe" GOTO end_if_copy_246
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_246
  @IF ERRORLEVEL 1 @TYPE exe_error_246 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_246
:end_if_copy_246
:end_if_release_218
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_219
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Xt.exe" GOTO end_if_copy_247
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_247
  @IF ERRORLEVEL 1 @TYPE exe_error_247 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_247
:end_if_copy_247
:end_if_release_219
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_220
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Xt.exe" GOTO end_if_copy_248
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_248
  @IF ERRORLEVEL 1 @TYPE exe_error_248 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_248
:end_if_copy_248
:end_if_release_220
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_221
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_HepEventViewer_Xt.exe" GOTO end_if_copy_249
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_HepEventViewer_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_249
  @IF ERRORLEVEL 1 @TYPE exe_error_249 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_249
:end_if_copy_249
:end_if_release_221
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_222
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_HepViewer_Xt.exe" GOTO end_if_copy_250
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_HepViewer_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_250
  @IF ERRORLEVEL 1 @TYPE exe_error_250 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_250
:end_if_copy_250
:end_if_release_222
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_223
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_XmColorChooser_Xt.exe" GOTO end_if_copy_251
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_XmColorChooser_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_251
  @IF ERRORLEVEL 1 @TYPE exe_error_251 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_251
:end_if_copy_251
:end_if_release_223
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_224
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_TestSoXtGui_Xt.exe" GOTO end_if_copy_252
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_TestSoXtGui_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_252
  @IF ERRORLEVEL 1 @TYPE exe_error_252 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_252
:end_if_copy_252
:end_if_release_224
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_225
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_TestHvTwig_Xt.exe" GOTO end_if_copy_253
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_TestHvTwig_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_253
  @IF ERRORLEVEL 1 @TYPE exe_error_253 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_253
:end_if_copy_253
:end_if_release_225
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_226
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Xt.exe" GOTO end_if_copy_254
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_254
  @IF ERRORLEVEL 1 @TYPE exe_error_254 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_254
:end_if_copy_254
:end_if_release_226
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_227
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_Xt.exe" GOTO end_if_copy_255
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_255
  @IF ERRORLEVEL 1 @TYPE exe_error_255 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_255
:end_if_copy_255
:end_if_release_227
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_228
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_Xt.exe" GOTO end_if_copy_256
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_256
  @IF ERRORLEVEL 1 @TYPE exe_error_256 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_256
:end_if_copy_256
:end_if_release_228
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_229
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Xt.exe" GOTO end_if_copy_257
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_257
  @IF ERRORLEVEL 1 @TYPE exe_error_257 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_257
:end_if_copy_257
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\view_hiv.exe" GOTO end_if_copy_258
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\view_hiv.exe" "%obuild_dir_project%\bin\." 1> exe_error_258
  @IF ERRORLEVEL 1 @TYPE exe_error_258 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_258
:end_if_copy_258
:end_if_release_229
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_230
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Xt.exe" GOTO end_if_copy_259
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Xt.exe" "%obuild_dir_project%\bin\." 1> exe_error_259
  @IF ERRORLEVEL 1 @TYPE exe_error_259 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_259
:end_if_copy_259
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\view_iv.exe" GOTO end_if_copy_260
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\view_iv.exe" "%obuild_dir_project%\bin\." 1> exe_error_260
  @IF ERRORLEVEL 1 @TYPE exe_error_260 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_260
:end_if_copy_260
:end_if_release_230
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_231
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Win.exe" GOTO end_if_copy_261
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_261
  @IF ERRORLEVEL 1 @TYPE exe_error_261 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_261
:end_if_copy_261
:end_if_release_231
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_232
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Win.exe" GOTO end_if_copy_262
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_262
  @IF ERRORLEVEL 1 @TYPE exe_error_262 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_262
:end_if_copy_262
:end_if_release_232
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_233
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Win.exe" GOTO end_if_copy_263
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_263
  @IF ERRORLEVEL 1 @TYPE exe_error_263 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_263
:end_if_copy_263
:end_if_release_233
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_234
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Win.exe" GOTO end_if_copy_264
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_264
  @IF ERRORLEVEL 1 @TYPE exe_error_264 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_264
:end_if_copy_264
:end_if_release_234
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_235
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Win.exe" GOTO end_if_copy_265
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_265
  @IF ERRORLEVEL 1 @TYPE exe_error_265 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_265
:end_if_copy_265
:end_if_release_235
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_236
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Win.exe" GOTO end_if_copy_266
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_266
  @IF ERRORLEVEL 1 @TYPE exe_error_266 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_266
:end_if_copy_266
:end_if_release_236
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_237
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Win.exe" GOTO end_if_copy_267
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_267
  @IF ERRORLEVEL 1 @TYPE exe_error_267 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_267
:end_if_copy_267
:end_if_release_237
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_238
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Win.exe" GOTO end_if_copy_268
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_268
  @IF ERRORLEVEL 1 @TYPE exe_error_268 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_268
:end_if_copy_268
:end_if_release_238
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_239
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Win.exe" GOTO end_if_copy_269
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_269
  @IF ERRORLEVEL 1 @TYPE exe_error_269 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_269
:end_if_copy_269
:end_if_release_239
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_240
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Win.exe" GOTO end_if_copy_270
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_270
  @IF ERRORLEVEL 1 @TYPE exe_error_270 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_270
:end_if_copy_270
:end_if_release_240
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_241
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Win.exe" GOTO end_if_copy_271
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_271
  @IF ERRORLEVEL 1 @TYPE exe_error_271 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_271
:end_if_copy_271
:end_if_release_241
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_242
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Win.exe" GOTO end_if_copy_272
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_272
  @IF ERRORLEVEL 1 @TYPE exe_error_272 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_272
:end_if_copy_272
:end_if_release_242
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_243
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Win.exe" GOTO end_if_copy_273
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_273
  @IF ERRORLEVEL 1 @TYPE exe_error_273 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_273
:end_if_copy_273
:end_if_release_243
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_244
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Win.exe" GOTO end_if_copy_274
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_274
  @IF ERRORLEVEL 1 @TYPE exe_error_274 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_274
:end_if_copy_274
:end_if_release_244
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_245
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Win.exe" GOTO end_if_copy_275
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_275
  @IF ERRORLEVEL 1 @TYPE exe_error_275 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_275
:end_if_copy_275
:end_if_release_245
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_246
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Win.exe" GOTO end_if_copy_276
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_276
  @IF ERRORLEVEL 1 @TYPE exe_error_276 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_276
:end_if_copy_276
:end_if_release_246
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_247
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Win.exe" GOTO end_if_copy_277
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_277
  @IF ERRORLEVEL 1 @TYPE exe_error_277 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_277
:end_if_copy_277
:end_if_release_247
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_248
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Win.exe" GOTO end_if_copy_278
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_278
  @IF ERRORLEVEL 1 @TYPE exe_error_278 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_278
:end_if_copy_278
:end_if_release_248
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_249
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Win.exe" GOTO end_if_copy_279
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_279
  @IF ERRORLEVEL 1 @TYPE exe_error_279 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_279
:end_if_copy_279
:end_if_release_249
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_250
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Win.exe" GOTO end_if_copy_280
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_280
  @IF ERRORLEVEL 1 @TYPE exe_error_280 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_280
:end_if_copy_280
:end_if_release_250
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_251
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Win.exe" GOTO end_if_copy_281
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_281
  @IF ERRORLEVEL 1 @TYPE exe_error_281 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_281
:end_if_copy_281
:end_if_release_251
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_252
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Win.exe" GOTO end_if_copy_282
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_282
  @IF ERRORLEVEL 1 @TYPE exe_error_282 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_282
:end_if_copy_282
:end_if_release_252
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_253
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Win.exe" GOTO end_if_copy_283
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_283
  @IF ERRORLEVEL 1 @TYPE exe_error_283 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_283
:end_if_copy_283
:end_if_release_253
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_254
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Win.exe" GOTO end_if_copy_284
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_284
  @IF ERRORLEVEL 1 @TYPE exe_error_284 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_284
:end_if_copy_284
:end_if_release_254
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_255
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Win.exe" GOTO end_if_copy_285
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_285
  @IF ERRORLEVEL 1 @TYPE exe_error_285 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_285
:end_if_copy_285
:end_if_release_255
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_256
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Win.exe" GOTO end_if_copy_286
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_286
  @IF ERRORLEVEL 1 @TYPE exe_error_286 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_286
:end_if_copy_286
:end_if_release_256
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_257
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Win.exe" GOTO end_if_copy_287
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_287
  @IF ERRORLEVEL 1 @TYPE exe_error_287 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_287
:end_if_copy_287
:end_if_release_257
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_258
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Win.exe" GOTO end_if_copy_288
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_288
  @IF ERRORLEVEL 1 @TYPE exe_error_288 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_288
:end_if_copy_288
:end_if_release_258
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_259
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Win.exe" GOTO end_if_copy_289
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_289
  @IF ERRORLEVEL 1 @TYPE exe_error_289 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_289
:end_if_copy_289
:end_if_release_259
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_260
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Win.exe" GOTO end_if_copy_290
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_290
  @IF ERRORLEVEL 1 @TYPE exe_error_290 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_290
:end_if_copy_290
:end_if_release_260
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_261
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Win.exe" GOTO end_if_copy_291
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_291
  @IF ERRORLEVEL 1 @TYPE exe_error_291 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_291
:end_if_copy_291
:end_if_release_261
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_262
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Win.exe" GOTO end_if_copy_292
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_292
  @IF ERRORLEVEL 1 @TYPE exe_error_292 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_292
:end_if_copy_292
:end_if_release_262
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_263
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Win.exe" GOTO end_if_copy_293
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_293
  @IF ERRORLEVEL 1 @TYPE exe_error_293 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_293
:end_if_copy_293
:end_if_release_263
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_264
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Win.exe" GOTO end_if_copy_294
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_294
  @IF ERRORLEVEL 1 @TYPE exe_error_294 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_294
:end_if_copy_294
:end_if_release_264
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_265
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Win.exe" GOTO end_if_copy_295
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_295
  @IF ERRORLEVEL 1 @TYPE exe_error_295 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_295
:end_if_copy_295
:end_if_release_265
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_266
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Win.exe" GOTO end_if_copy_296
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_296
  @IF ERRORLEVEL 1 @TYPE exe_error_296 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_296
:end_if_copy_296
:end_if_release_266
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_267
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Win.exe" GOTO end_if_copy_297
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_297
  @IF ERRORLEVEL 1 @TYPE exe_error_297 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_297
:end_if_copy_297
:end_if_release_267
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_268
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Win.exe" GOTO end_if_copy_298
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_298
  @IF ERRORLEVEL 1 @TYPE exe_error_298 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_298
:end_if_copy_298
:end_if_release_268
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_269
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Win.exe" GOTO end_if_copy_299
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_299
  @IF ERRORLEVEL 1 @TYPE exe_error_299 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_299
:end_if_copy_299
:end_if_release_269
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_270
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Win.exe" GOTO end_if_copy_300
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_300
  @IF ERRORLEVEL 1 @TYPE exe_error_300 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_300
:end_if_copy_300
:end_if_release_270
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_271
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Win.exe" GOTO end_if_copy_301
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_301
  @IF ERRORLEVEL 1 @TYPE exe_error_301 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_301
:end_if_copy_301
:end_if_release_271
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_272
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Win.exe" GOTO end_if_copy_302
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_302
  @IF ERRORLEVEL 1 @TYPE exe_error_302 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_302
:end_if_copy_302
:end_if_release_272
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_273
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Win.exe" GOTO end_if_copy_303
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_303
  @IF ERRORLEVEL 1 @TYPE exe_error_303 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_303
:end_if_copy_303
:end_if_release_273
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_274
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Win.exe" GOTO end_if_copy_304
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_304
  @IF ERRORLEVEL 1 @TYPE exe_error_304 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_304
:end_if_copy_304
:end_if_release_274
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_275
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Win.exe" GOTO end_if_copy_305
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_305
  @IF ERRORLEVEL 1 @TYPE exe_error_305 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_305
:end_if_copy_305
:end_if_release_275
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_276
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Win.exe" GOTO end_if_copy_306
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_306
  @IF ERRORLEVEL 1 @TYPE exe_error_306 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_306
:end_if_copy_306
:end_if_release_276
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_277
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Win.exe" GOTO end_if_copy_307
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_307
  @IF ERRORLEVEL 1 @TYPE exe_error_307 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_307
:end_if_copy_307
:end_if_release_277
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_278
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Win.exe" GOTO end_if_copy_308
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_308
  @IF ERRORLEVEL 1 @TYPE exe_error_308 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_308
:end_if_copy_308
:end_if_release_278
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_279
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Win.exe" GOTO end_if_copy_309
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_309
  @IF ERRORLEVEL 1 @TYPE exe_error_309 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_309
:end_if_copy_309
:end_if_release_279
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_280
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Win.exe" GOTO end_if_copy_310
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_310
  @IF ERRORLEVEL 1 @TYPE exe_error_310 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_310
:end_if_copy_310
:end_if_release_280
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_281
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Win.exe" GOTO end_if_copy_311
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_311
  @IF ERRORLEVEL 1 @TYPE exe_error_311 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_311
:end_if_copy_311
:end_if_release_281
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_282
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Win.exe" GOTO end_if_copy_312
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_312
  @IF ERRORLEVEL 1 @TYPE exe_error_312 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_312
:end_if_copy_312
:end_if_release_282
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_283
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Win.exe" GOTO end_if_copy_313
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_313
  @IF ERRORLEVEL 1 @TYPE exe_error_313 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_313
:end_if_copy_313
:end_if_release_283
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_284
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Win.exe" GOTO end_if_copy_314
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_314
  @IF ERRORLEVEL 1 @TYPE exe_error_314 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_314
:end_if_copy_314
:end_if_release_284
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_285
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Win.exe" GOTO end_if_copy_315
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_315
  @IF ERRORLEVEL 1 @TYPE exe_error_315 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_315
:end_if_copy_315
:end_if_release_285
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_286
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Win.exe" GOTO end_if_copy_316
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_316
  @IF ERRORLEVEL 1 @TYPE exe_error_316 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_316
:end_if_copy_316
:end_if_release_286
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_287
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Win.exe" GOTO end_if_copy_317
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_317
  @IF ERRORLEVEL 1 @TYPE exe_error_317 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_317
:end_if_copy_317
:end_if_release_287
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_288
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Win.exe" GOTO end_if_copy_318
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_318
  @IF ERRORLEVEL 1 @TYPE exe_error_318 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_318
:end_if_copy_318
:end_if_release_288
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_289
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Win.exe" GOTO end_if_copy_319
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_319
  @IF ERRORLEVEL 1 @TYPE exe_error_319 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_319
:end_if_copy_319
:end_if_release_289
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_290
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Win.exe" GOTO end_if_copy_320
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_320
  @IF ERRORLEVEL 1 @TYPE exe_error_320 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_320
:end_if_copy_320
:end_if_release_290
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_291
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Win.exe" GOTO end_if_copy_321
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_321
  @IF ERRORLEVEL 1 @TYPE exe_error_321 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_321
:end_if_copy_321
:end_if_release_291
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_292
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Win.exe" GOTO end_if_copy_322
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_322
  @IF ERRORLEVEL 1 @TYPE exe_error_322 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_322
:end_if_copy_322
:end_if_release_292
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_293
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Win.exe" GOTO end_if_copy_323
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_323
  @IF ERRORLEVEL 1 @TYPE exe_error_323 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_323
:end_if_copy_323
:end_if_release_293
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_294
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Win.exe" GOTO end_if_copy_324
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_324
  @IF ERRORLEVEL 1 @TYPE exe_error_324 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_324
:end_if_copy_324
:end_if_release_294
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_295
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Win.exe" GOTO end_if_copy_325
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_325
  @IF ERRORLEVEL 1 @TYPE exe_error_325 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_325
:end_if_copy_325
:end_if_release_295
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_296
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Win.exe" GOTO end_if_copy_326
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_326
  @IF ERRORLEVEL 1 @TYPE exe_error_326 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_326
:end_if_copy_326
:end_if_release_296
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_297
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Win.exe" GOTO end_if_copy_327
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_327
  @IF ERRORLEVEL 1 @TYPE exe_error_327 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_327
:end_if_copy_327
:end_if_release_297
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_298
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Win.exe" GOTO end_if_copy_328
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_328
  @IF ERRORLEVEL 1 @TYPE exe_error_328 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_328
:end_if_copy_328
:end_if_release_298
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_299
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Win.exe" GOTO end_if_copy_329
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Win.exe" "%obuild_dir_project%\bin\." 1> exe_error_329
  @IF ERRORLEVEL 1 @TYPE exe_error_329 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_329
:end_if_copy_329
:end_if_release_299
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_300
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Qt.exe" GOTO end_if_copy_330
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_330
  @IF ERRORLEVEL 1 @TYPE exe_error_330 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_330
:end_if_copy_330
:end_if_release_300
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_301
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Qt.exe" GOTO end_if_copy_331
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_331
  @IF ERRORLEVEL 1 @TYPE exe_error_331 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_331
:end_if_copy_331
:end_if_release_301
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_302
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Qt.exe" GOTO end_if_copy_332
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_332
  @IF ERRORLEVEL 1 @TYPE exe_error_332 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_332
:end_if_copy_332
:end_if_release_302
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_303
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Qt.exe" GOTO end_if_copy_333
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_333
  @IF ERRORLEVEL 1 @TYPE exe_error_333 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_333
:end_if_copy_333
:end_if_release_303
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_304
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Qt.exe" GOTO end_if_copy_334
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_334
  @IF ERRORLEVEL 1 @TYPE exe_error_334 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_334
:end_if_copy_334
:end_if_release_304
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_305
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Qt.exe" GOTO end_if_copy_335
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_335
  @IF ERRORLEVEL 1 @TYPE exe_error_335 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_335
:end_if_copy_335
:end_if_release_305
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_306
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Qt.exe" GOTO end_if_copy_336
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_336
  @IF ERRORLEVEL 1 @TYPE exe_error_336 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_336
:end_if_copy_336
:end_if_release_306
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_307
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Qt.exe" GOTO end_if_copy_337
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_337
  @IF ERRORLEVEL 1 @TYPE exe_error_337 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_337
:end_if_copy_337
:end_if_release_307
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_308
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Qt.exe" GOTO end_if_copy_338
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_338
  @IF ERRORLEVEL 1 @TYPE exe_error_338 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_338
:end_if_copy_338
:end_if_release_308
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_309
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Qt.exe" GOTO end_if_copy_339
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_339
  @IF ERRORLEVEL 1 @TYPE exe_error_339 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_339
:end_if_copy_339
:end_if_release_309
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_310
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Qt.exe" GOTO end_if_copy_340
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_340
  @IF ERRORLEVEL 1 @TYPE exe_error_340 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_340
:end_if_copy_340
:end_if_release_310
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_311
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Qt.exe" GOTO end_if_copy_341
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_341
  @IF ERRORLEVEL 1 @TYPE exe_error_341 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_341
:end_if_copy_341
:end_if_release_311
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_312
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Qt.exe" GOTO end_if_copy_342
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_342
  @IF ERRORLEVEL 1 @TYPE exe_error_342 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_342
:end_if_copy_342
:end_if_release_312
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_313
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Qt.exe" GOTO end_if_copy_343
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_343
  @IF ERRORLEVEL 1 @TYPE exe_error_343 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_343
:end_if_copy_343
:end_if_release_313
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_314
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Qt.exe" GOTO end_if_copy_344
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_344
  @IF ERRORLEVEL 1 @TYPE exe_error_344 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_344
:end_if_copy_344
:end_if_release_314
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_315
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Qt.exe" GOTO end_if_copy_345
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_345
  @IF ERRORLEVEL 1 @TYPE exe_error_345 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_345
:end_if_copy_345
:end_if_release_315
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_316
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Qt.exe" GOTO end_if_copy_346
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_346
  @IF ERRORLEVEL 1 @TYPE exe_error_346 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_346
:end_if_copy_346
:end_if_release_316
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_317
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Qt.exe" GOTO end_if_copy_347
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_347
  @IF ERRORLEVEL 1 @TYPE exe_error_347 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_347
:end_if_copy_347
:end_if_release_317
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_318
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Qt.exe" GOTO end_if_copy_348
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_348
  @IF ERRORLEVEL 1 @TYPE exe_error_348 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_348
:end_if_copy_348
:end_if_release_318
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_319
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Qt.exe" GOTO end_if_copy_349
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_349
  @IF ERRORLEVEL 1 @TYPE exe_error_349 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_349
:end_if_copy_349
:end_if_release_319
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_320
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Qt.exe" GOTO end_if_copy_350
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_350
  @IF ERRORLEVEL 1 @TYPE exe_error_350 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_350
:end_if_copy_350
:end_if_release_320
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_321
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Qt.exe" GOTO end_if_copy_351
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_351
  @IF ERRORLEVEL 1 @TYPE exe_error_351 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_351
:end_if_copy_351
:end_if_release_321
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_322
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Qt.exe" GOTO end_if_copy_352
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_352
  @IF ERRORLEVEL 1 @TYPE exe_error_352 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_352
:end_if_copy_352
:end_if_release_322
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_323
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Qt.exe" GOTO end_if_copy_353
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_353
  @IF ERRORLEVEL 1 @TYPE exe_error_353 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_353
:end_if_copy_353
:end_if_release_323
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_324
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Qt.exe" GOTO end_if_copy_354
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_354
  @IF ERRORLEVEL 1 @TYPE exe_error_354 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_354
:end_if_copy_354
:end_if_release_324
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_325
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Qt.exe" GOTO end_if_copy_355
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_355
  @IF ERRORLEVEL 1 @TYPE exe_error_355 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_355
:end_if_copy_355
:end_if_release_325
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_326
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Qt.exe" GOTO end_if_copy_356
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_356
  @IF ERRORLEVEL 1 @TYPE exe_error_356 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_356
:end_if_copy_356
:end_if_release_326
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_327
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Qt.exe" GOTO end_if_copy_357
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_357
  @IF ERRORLEVEL 1 @TYPE exe_error_357 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_357
:end_if_copy_357
:end_if_release_327
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_328
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Qt.exe" GOTO end_if_copy_358
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_358
  @IF ERRORLEVEL 1 @TYPE exe_error_358 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_358
:end_if_copy_358
:end_if_release_328
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_329
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Qt.exe" GOTO end_if_copy_359
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_359
  @IF ERRORLEVEL 1 @TYPE exe_error_359 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_359
:end_if_copy_359
:end_if_release_329
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_330
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Qt.exe" GOTO end_if_copy_360
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_360
  @IF ERRORLEVEL 1 @TYPE exe_error_360 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_360
:end_if_copy_360
:end_if_release_330
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_331
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Qt.exe" GOTO end_if_copy_361
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_361
  @IF ERRORLEVEL 1 @TYPE exe_error_361 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_361
:end_if_copy_361
:end_if_release_331
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_332
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Qt.exe" GOTO end_if_copy_362
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_362
  @IF ERRORLEVEL 1 @TYPE exe_error_362 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_362
:end_if_copy_362
:end_if_release_332
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_333
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Qt.exe" GOTO end_if_copy_363
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_363
  @IF ERRORLEVEL 1 @TYPE exe_error_363 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_363
:end_if_copy_363
:end_if_release_333
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_334
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Qt.exe" GOTO end_if_copy_364
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_364
  @IF ERRORLEVEL 1 @TYPE exe_error_364 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_364
:end_if_copy_364
:end_if_release_334
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_335
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Qt.exe" GOTO end_if_copy_365
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_365
  @IF ERRORLEVEL 1 @TYPE exe_error_365 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_365
:end_if_copy_365
:end_if_release_335
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_336
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Qt.exe" GOTO end_if_copy_366
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_366
  @IF ERRORLEVEL 1 @TYPE exe_error_366 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_366
:end_if_copy_366
:end_if_release_336
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_337
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Qt.exe" GOTO end_if_copy_367
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_367
  @IF ERRORLEVEL 1 @TYPE exe_error_367 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_367
:end_if_copy_367
:end_if_release_337
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_338
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Qt.exe" GOTO end_if_copy_368
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_368
  @IF ERRORLEVEL 1 @TYPE exe_error_368 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_368
:end_if_copy_368
:end_if_release_338
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_339
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Qt.exe" GOTO end_if_copy_369
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_369
  @IF ERRORLEVEL 1 @TYPE exe_error_369 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_369
:end_if_copy_369
:end_if_release_339
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_340
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Qt.exe" GOTO end_if_copy_370
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_370
  @IF ERRORLEVEL 1 @TYPE exe_error_370 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_370
:end_if_copy_370
:end_if_release_340
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_341
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Qt.exe" GOTO end_if_copy_371
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_371
  @IF ERRORLEVEL 1 @TYPE exe_error_371 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_371
:end_if_copy_371
:end_if_release_341
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_342
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Qt.exe" GOTO end_if_copy_372
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_372
  @IF ERRORLEVEL 1 @TYPE exe_error_372 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_372
:end_if_copy_372
:end_if_release_342
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_343
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Qt.exe" GOTO end_if_copy_373
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_373
  @IF ERRORLEVEL 1 @TYPE exe_error_373 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_373
:end_if_copy_373
:end_if_release_343
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_344
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Qt.exe" GOTO end_if_copy_374
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_374
  @IF ERRORLEVEL 1 @TYPE exe_error_374 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_374
:end_if_copy_374
:end_if_release_344
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_345
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Qt.exe" GOTO end_if_copy_375
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_375
  @IF ERRORLEVEL 1 @TYPE exe_error_375 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_375
:end_if_copy_375
:end_if_release_345
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_346
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Qt.exe" GOTO end_if_copy_376
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_376
  @IF ERRORLEVEL 1 @TYPE exe_error_376 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_376
:end_if_copy_376
:end_if_release_346
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_347
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Qt.exe" GOTO end_if_copy_377
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_377
  @IF ERRORLEVEL 1 @TYPE exe_error_377 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_377
:end_if_copy_377
:end_if_release_347
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_348
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Qt.exe" GOTO end_if_copy_378
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_378
  @IF ERRORLEVEL 1 @TYPE exe_error_378 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_378
:end_if_copy_378
:end_if_release_348
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_349
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Qt.exe" GOTO end_if_copy_379
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_379
  @IF ERRORLEVEL 1 @TYPE exe_error_379 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_379
:end_if_copy_379
:end_if_release_349
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_350
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Qt.exe" GOTO end_if_copy_380
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_380
  @IF ERRORLEVEL 1 @TYPE exe_error_380 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_380
:end_if_copy_380
:end_if_release_350
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_351
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Qt.exe" GOTO end_if_copy_381
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_381
  @IF ERRORLEVEL 1 @TYPE exe_error_381 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_381
:end_if_copy_381
:end_if_release_351
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_352
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Qt.exe" GOTO end_if_copy_382
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_382
  @IF ERRORLEVEL 1 @TYPE exe_error_382 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_382
:end_if_copy_382
:end_if_release_352
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_353
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Qt.exe" GOTO end_if_copy_383
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_383
  @IF ERRORLEVEL 1 @TYPE exe_error_383 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_383
:end_if_copy_383
:end_if_release_353
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_354
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Qt.exe" GOTO end_if_copy_384
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_384
  @IF ERRORLEVEL 1 @TYPE exe_error_384 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_384
:end_if_copy_384
:end_if_release_354
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_355
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Qt.exe" GOTO end_if_copy_385
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_385
  @IF ERRORLEVEL 1 @TYPE exe_error_385 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_385
:end_if_copy_385
:end_if_release_355
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_356
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Qt.exe" GOTO end_if_copy_386
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_386
  @IF ERRORLEVEL 1 @TYPE exe_error_386 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_386
:end_if_copy_386
:end_if_release_356
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_357
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Qt.exe" GOTO end_if_copy_387
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_387
  @IF ERRORLEVEL 1 @TYPE exe_error_387 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_387
:end_if_copy_387
:end_if_release_357
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_358
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Qt.exe" GOTO end_if_copy_388
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_388
  @IF ERRORLEVEL 1 @TYPE exe_error_388 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_388
:end_if_copy_388
:end_if_release_358
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_359
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Qt.exe" GOTO end_if_copy_389
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_389
  @IF ERRORLEVEL 1 @TYPE exe_error_389 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_389
:end_if_copy_389
:end_if_release_359
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_360
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Qt.exe" GOTO end_if_copy_390
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_390
  @IF ERRORLEVEL 1 @TYPE exe_error_390 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_390
:end_if_copy_390
:end_if_release_360
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_361
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Qt.exe" GOTO end_if_copy_391
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_391
  @IF ERRORLEVEL 1 @TYPE exe_error_391 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_391
:end_if_copy_391
:end_if_release_361
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_362
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Qt.exe" GOTO end_if_copy_392
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_392
  @IF ERRORLEVEL 1 @TYPE exe_error_392 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_392
:end_if_copy_392
:end_if_release_362
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_363
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Qt.exe" GOTO end_if_copy_393
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_393
  @IF ERRORLEVEL 1 @TYPE exe_error_393 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_393
:end_if_copy_393
:end_if_release_363
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_364
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Qt.exe" GOTO end_if_copy_394
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_394
  @IF ERRORLEVEL 1 @TYPE exe_error_394 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_394
:end_if_copy_394
:end_if_release_364
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_365
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Qt.exe" GOTO end_if_copy_395
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Qt.exe" "%obuild_dir_project%\bin\." 1> exe_error_395
  @IF ERRORLEVEL 1 @TYPE exe_error_395 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_395
:end_if_copy_395
:end_if_release_365
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_366
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_gtk.exe" GOTO end_if_copy_396
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_396
  @IF ERRORLEVEL 1 @TYPE exe_error_396 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_396
:end_if_copy_396
:end_if_release_366
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_367
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_gtk.exe" GOTO end_if_copy_397
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_397
  @IF ERRORLEVEL 1 @TYPE exe_error_397 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_397
:end_if_copy_397
:end_if_release_367
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_368
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_gtk.exe" GOTO end_if_copy_398
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_398
  @IF ERRORLEVEL 1 @TYPE exe_error_398 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_398
:end_if_copy_398
:end_if_release_368
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_369
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_gtk.exe" GOTO end_if_copy_399
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_399
  @IF ERRORLEVEL 1 @TYPE exe_error_399 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_399
:end_if_copy_399
:end_if_release_369
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_370
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_gtk.exe" GOTO end_if_copy_400
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_400
  @IF ERRORLEVEL 1 @TYPE exe_error_400 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_400
:end_if_copy_400
:end_if_release_370
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_371
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_gtk.exe" GOTO end_if_copy_401
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_401
  @IF ERRORLEVEL 1 @TYPE exe_error_401 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_401
:end_if_copy_401
:end_if_release_371
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_372
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_gtk.exe" GOTO end_if_copy_402
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_402
  @IF ERRORLEVEL 1 @TYPE exe_error_402 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_402
:end_if_copy_402
:end_if_release_372
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_373
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_gtk.exe" GOTO end_if_copy_403
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_403
  @IF ERRORLEVEL 1 @TYPE exe_error_403 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_403
:end_if_copy_403
:end_if_release_373
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_374
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_gtk.exe" GOTO end_if_copy_404
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_404
  @IF ERRORLEVEL 1 @TYPE exe_error_404 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_404
:end_if_copy_404
:end_if_release_374
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_375
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_gtk.exe" GOTO end_if_copy_405
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_405
  @IF ERRORLEVEL 1 @TYPE exe_error_405 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_405
:end_if_copy_405
:end_if_release_375
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_376
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_gtk.exe" GOTO end_if_copy_406
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_406
  @IF ERRORLEVEL 1 @TYPE exe_error_406 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_406
:end_if_copy_406
:end_if_release_376
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_377
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_gtk.exe" GOTO end_if_copy_407
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_407
  @IF ERRORLEVEL 1 @TYPE exe_error_407 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_407
:end_if_copy_407
:end_if_release_377
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_378
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_gtk.exe" GOTO end_if_copy_408
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_408
  @IF ERRORLEVEL 1 @TYPE exe_error_408 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_408
:end_if_copy_408
:end_if_release_378
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_379
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_gtk.exe" GOTO end_if_copy_409
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_409
  @IF ERRORLEVEL 1 @TYPE exe_error_409 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_409
:end_if_copy_409
:end_if_release_379
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_380
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_gtk.exe" GOTO end_if_copy_410
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_410
  @IF ERRORLEVEL 1 @TYPE exe_error_410 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_410
:end_if_copy_410
:end_if_release_380
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_381
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_gtk.exe" GOTO end_if_copy_411
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_411
  @IF ERRORLEVEL 1 @TYPE exe_error_411 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_411
:end_if_copy_411
:end_if_release_381
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_382
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_gtk.exe" GOTO end_if_copy_412
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_412
  @IF ERRORLEVEL 1 @TYPE exe_error_412 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_412
:end_if_copy_412
:end_if_release_382
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_383
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_gtk.exe" GOTO end_if_copy_413
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_413
  @IF ERRORLEVEL 1 @TYPE exe_error_413 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_413
:end_if_copy_413
:end_if_release_383
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_384
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_gtk.exe" GOTO end_if_copy_414
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_414
  @IF ERRORLEVEL 1 @TYPE exe_error_414 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_414
:end_if_copy_414
:end_if_release_384
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_385
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_gtk.exe" GOTO end_if_copy_415
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_415
  @IF ERRORLEVEL 1 @TYPE exe_error_415 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_415
:end_if_copy_415
:end_if_release_385
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_386
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_gtk.exe" GOTO end_if_copy_416
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_416
  @IF ERRORLEVEL 1 @TYPE exe_error_416 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_416
:end_if_copy_416
:end_if_release_386
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_387
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_gtk.exe" GOTO end_if_copy_417
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_417
  @IF ERRORLEVEL 1 @TYPE exe_error_417 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_417
:end_if_copy_417
:end_if_release_387
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_388
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_gtk.exe" GOTO end_if_copy_418
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_418
  @IF ERRORLEVEL 1 @TYPE exe_error_418 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_418
:end_if_copy_418
:end_if_release_388
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_389
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_gtk.exe" GOTO end_if_copy_419
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_419
  @IF ERRORLEVEL 1 @TYPE exe_error_419 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_419
:end_if_copy_419
:end_if_release_389
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_390
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_gtk.exe" GOTO end_if_copy_420
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_420
  @IF ERRORLEVEL 1 @TYPE exe_error_420 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_420
:end_if_copy_420
:end_if_release_390
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_391
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_gtk.exe" GOTO end_if_copy_421
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_421
  @IF ERRORLEVEL 1 @TYPE exe_error_421 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_421
:end_if_copy_421
:end_if_release_391
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_392
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_gtk.exe" GOTO end_if_copy_422
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_422
  @IF ERRORLEVEL 1 @TYPE exe_error_422 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_422
:end_if_copy_422
:end_if_release_392
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_393
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_gtk.exe" GOTO end_if_copy_423
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_423
  @IF ERRORLEVEL 1 @TYPE exe_error_423 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_423
:end_if_copy_423
:end_if_release_393
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_394
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_gtk.exe" GOTO end_if_copy_424
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_424
  @IF ERRORLEVEL 1 @TYPE exe_error_424 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_424
:end_if_copy_424
:end_if_release_394
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_395
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_gtk.exe" GOTO end_if_copy_425
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_425
  @IF ERRORLEVEL 1 @TYPE exe_error_425 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_425
:end_if_copy_425
:end_if_release_395
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_396
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_gtk.exe" GOTO end_if_copy_426
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_426
  @IF ERRORLEVEL 1 @TYPE exe_error_426 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_426
:end_if_copy_426
:end_if_release_396
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_397
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_gtk.exe" GOTO end_if_copy_427
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_427
  @IF ERRORLEVEL 1 @TYPE exe_error_427 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_427
:end_if_copy_427
:end_if_release_397
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_398
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_gtk.exe" GOTO end_if_copy_428
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_428
  @IF ERRORLEVEL 1 @TYPE exe_error_428 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_428
:end_if_copy_428
:end_if_release_398
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_399
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_gtk.exe" GOTO end_if_copy_429
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_429
  @IF ERRORLEVEL 1 @TYPE exe_error_429 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_429
:end_if_copy_429
:end_if_release_399
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_400
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_gtk.exe" GOTO end_if_copy_430
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_430
  @IF ERRORLEVEL 1 @TYPE exe_error_430 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_430
:end_if_copy_430
:end_if_release_400
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_401
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_gtk.exe" GOTO end_if_copy_431
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_431
  @IF ERRORLEVEL 1 @TYPE exe_error_431 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_431
:end_if_copy_431
:end_if_release_401
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_402
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_gtk.exe" GOTO end_if_copy_432
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_432
  @IF ERRORLEVEL 1 @TYPE exe_error_432 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_432
:end_if_copy_432
:end_if_release_402
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_403
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_gtk.exe" GOTO end_if_copy_433
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_433
  @IF ERRORLEVEL 1 @TYPE exe_error_433 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_433
:end_if_copy_433
:end_if_release_403
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_404
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_gtk.exe" GOTO end_if_copy_434
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_434
  @IF ERRORLEVEL 1 @TYPE exe_error_434 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_434
:end_if_copy_434
:end_if_release_404
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_405
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_gtk.exe" GOTO end_if_copy_435
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_435
  @IF ERRORLEVEL 1 @TYPE exe_error_435 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_435
:end_if_copy_435
:end_if_release_405
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_406
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_gtk.exe" GOTO end_if_copy_436
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_436
  @IF ERRORLEVEL 1 @TYPE exe_error_436 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_436
:end_if_copy_436
:end_if_release_406
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_407
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_gtk.exe" GOTO end_if_copy_437
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_437
  @IF ERRORLEVEL 1 @TYPE exe_error_437 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_437
:end_if_copy_437
:end_if_release_407
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_408
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_gtk.exe" GOTO end_if_copy_438
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_438
  @IF ERRORLEVEL 1 @TYPE exe_error_438 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_438
:end_if_copy_438
:end_if_release_408
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_409
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_gtk.exe" GOTO end_if_copy_439
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_439
  @IF ERRORLEVEL 1 @TYPE exe_error_439 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_439
:end_if_copy_439
:end_if_release_409
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_410
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_gtk.exe" GOTO end_if_copy_440
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_440
  @IF ERRORLEVEL 1 @TYPE exe_error_440 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_440
:end_if_copy_440
:end_if_release_410
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_411
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_gtk.exe" GOTO end_if_copy_441
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_441
  @IF ERRORLEVEL 1 @TYPE exe_error_441 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_441
:end_if_copy_441
:end_if_release_411
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_412
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_gtk.exe" GOTO end_if_copy_442
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_442
  @IF ERRORLEVEL 1 @TYPE exe_error_442 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_442
:end_if_copy_442
:end_if_release_412
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_413
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_gtk.exe" GOTO end_if_copy_443
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_443
  @IF ERRORLEVEL 1 @TYPE exe_error_443 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_443
:end_if_copy_443
:end_if_release_413
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_414
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_gtk.exe" GOTO end_if_copy_444
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_444
  @IF ERRORLEVEL 1 @TYPE exe_error_444 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_444
:end_if_copy_444
:end_if_release_414
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_415
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_gtk.exe" GOTO end_if_copy_445
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_445
  @IF ERRORLEVEL 1 @TYPE exe_error_445 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_445
:end_if_copy_445
:end_if_release_415
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_416
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_gtk.exe" GOTO end_if_copy_446
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_446
  @IF ERRORLEVEL 1 @TYPE exe_error_446 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_446
:end_if_copy_446
:end_if_release_416
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_417
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_gtk.exe" GOTO end_if_copy_447
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_447
  @IF ERRORLEVEL 1 @TYPE exe_error_447 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_447
:end_if_copy_447
:end_if_release_417
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_418
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_gtk.exe" GOTO end_if_copy_448
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_448
  @IF ERRORLEVEL 1 @TYPE exe_error_448 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_448
:end_if_copy_448
:end_if_release_418
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_419
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_gtk.exe" GOTO end_if_copy_449
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_449
  @IF ERRORLEVEL 1 @TYPE exe_error_449 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_449
:end_if_copy_449
:end_if_release_419
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_420
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_gtk.exe" GOTO end_if_copy_450
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_450
  @IF ERRORLEVEL 1 @TYPE exe_error_450 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_450
:end_if_copy_450
:end_if_release_420
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_421
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_gtk.exe" GOTO end_if_copy_451
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_451
  @IF ERRORLEVEL 1 @TYPE exe_error_451 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_451
:end_if_copy_451
:end_if_release_421
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_422
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_gtk.exe" GOTO end_if_copy_452
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_452
  @IF ERRORLEVEL 1 @TYPE exe_error_452 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_452
:end_if_copy_452
:end_if_release_422
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_423
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_gtk.exe" GOTO end_if_copy_453
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_453
  @IF ERRORLEVEL 1 @TYPE exe_error_453 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_453
:end_if_copy_453
:end_if_release_423
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_424
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_gtk.exe" GOTO end_if_copy_454
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_454
  @IF ERRORLEVEL 1 @TYPE exe_error_454 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_454
:end_if_copy_454
:end_if_release_424
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_425
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_gtk.exe" GOTO end_if_copy_455
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_455
  @IF ERRORLEVEL 1 @TYPE exe_error_455 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_455
:end_if_copy_455
:end_if_release_425
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_426
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_gtk.exe" GOTO end_if_copy_456
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_456
  @IF ERRORLEVEL 1 @TYPE exe_error_456 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_456
:end_if_copy_456
:end_if_release_426
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_427
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_gtk.exe" GOTO end_if_copy_457
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_457
  @IF ERRORLEVEL 1 @TYPE exe_error_457 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_457
:end_if_copy_457
:end_if_release_427
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_428
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_gtk.exe" GOTO end_if_copy_458
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_458
  @IF ERRORLEVEL 1 @TYPE exe_error_458 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_458
:end_if_copy_458
:end_if_release_428
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_429
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_gtk.exe" GOTO end_if_copy_459
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_459
  @IF ERRORLEVEL 1 @TYPE exe_error_459 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_459
:end_if_copy_459
:end_if_release_429
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_430
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_gtk.exe" GOTO end_if_copy_460
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_460
  @IF ERRORLEVEL 1 @TYPE exe_error_460 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_460
:end_if_copy_460
:end_if_release_430
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_431
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_gtk.exe" GOTO end_if_copy_461
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_gtk.exe" "%obuild_dir_project%\bin\." 1> exe_error_461
  @IF ERRORLEVEL 1 @TYPE exe_error_461 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_461
:end_if_copy_461
:end_if_release_431
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_432
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_SDL.exe" GOTO end_if_copy_462
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_SDL.exe" "%obuild_dir_project%\bin\." 1> exe_error_462
  @IF ERRORLEVEL 1 @TYPE exe_error_462 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_462
:end_if_copy_462
:end_if_release_432
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_433
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_SDL.exe" GOTO end_if_copy_463
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_SDL.exe" "%obuild_dir_project%\bin\." 1> exe_error_463
  @IF ERRORLEVEL 1 @TYPE exe_error_463 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_463
:end_if_copy_463
:end_if_release_433
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_434
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_SDL.exe" GOTO end_if_copy_464
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_SDL.exe" "%obuild_dir_project%\bin\." 1> exe_error_464
  @IF ERRORLEVEL 1 @TYPE exe_error_464 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_464
:end_if_copy_464
:end_if_release_434
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_435
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_GLUT.exe" GOTO end_if_copy_465
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_GLUT.exe" "%obuild_dir_project%\bin\." 1> exe_error_465
  @IF ERRORLEVEL 1 @TYPE exe_error_465 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_465
:end_if_copy_465
:end_if_release_435
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_436
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_GLUT.exe" GOTO end_if_copy_466
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_GLUT.exe" "%obuild_dir_project%\bin\." 1> exe_error_466
  @IF ERRORLEVEL 1 @TYPE exe_error_466 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_466
:end_if_copy_466
:end_if_release_436
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_437
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_GLUT.exe" GOTO end_if_copy_467
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_GLUT.exe" "%obuild_dir_project%\bin\." 1> exe_error_467
  @IF ERRORLEVEL 1 @TYPE exe_error_467 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_467
:end_if_copy_467
:end_if_release_437
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r15p3`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  GOTO end_if_release_438
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_GLUT.exe" GOTO end_if_copy_468
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_GLUT.exe" "%obuild_dir_project%\bin\." 1> exe_error_468
  @IF ERRORLEVEL 1 @TYPE exe_error_468 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_468
:end_if_copy_468
:end_if_release_438

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_iv_1=%%d
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe`) DO SET obuild_platform_signature=%%j
cd "%obuild_pwd_osc_iv_1%"
SET obuild_pwd_osc_iv_1=
IF EXIST "%obuild_dir_project%\desktop" RMDIR /S /Q "%obuild_dir_project%\desktop"
IF EXIST "%obuild_dir_project%\Resources/AIDA" RMDIR /S /Q "%obuild_dir_project%\Resources/AIDA"
FOR %%f IN ("%obuild_dir_project%"\Geant4-setup.*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\aida-setup.*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\owrap.exe DEL "%obuild_dir_project%\bin"\owrap.exe
FOR %%f IN ("%obuild_dir_project%\bin"\zip_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\zlib_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\h5_*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\expat_example.exe DEL "%obuild_dir_project%\bin"\expat_example.exe
IF EXIST "%obuild_dir_project%\bin"\fontGeneration.exe DEL "%obuild_dir_project%\bin"\fontGeneration.exe
IF EXIST "%obuild_dir_project%\bin"\dvi2bitmap.exe DEL "%obuild_dir_project%\bin"\dvi2bitmap.exe
IF EXIST "%obuild_dir_project%\bin"\dvireport.exe DEL "%obuild_dir_project%\bin"\dvireport.exe
FOR %%f IN ("%obuild_dir_project%\bin"\CoinGL_coin_*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\SDL_query_video.exe DEL "%obuild_dir_project%\bin"\SDL_query_video.exe
IF EXIST "%obuild_dir_project%\bin"\SoSDL_test_cube.exe DEL "%obuild_dir_project%\bin"\SoSDL_test_cube.exe
IF EXIST "%obuild_dir_project%\bin"\SoSDL_web.exe DEL "%obuild_dir_project%\bin"\SoSDL_web.exe
IF EXIST "%obuild_dir_project%\bin"\SoGLUT_test_cube.exe DEL "%obuild_dir_project%\bin"\SoGLUT_test_cube.exe
IF EXIST "%obuild_dir_project%\bin"\CoinGL_config_save.exe DEL "%obuild_dir_project%\bin"\CoinGL_config_save.exe
IF EXIST "%obuild_dir_project%\bin"\CoinXt_config_save.exe DEL "%obuild_dir_project%\bin"\CoinXt_config_save.exe
IF EXIST "%obuild_dir_project%\bin"\CoinQt_config_save.exe DEL "%obuild_dir_project%\bin"\CoinQt_config_save.exe
IF EXIST "%obuild_dir_project%\bin"\CoinGtk_config_save.exe DEL "%obuild_dir_project%\bin"\CoinGtk_config_save.exe
FOR %%f IN ("%obuild_dir_project%\bin"\CoinXt_test_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\CoinXt_coin_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\CoinGtk_test_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\CoinGtk_coin_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\CoinQt_test_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\CoinQt_coin_*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\soqt-config.exe DEL "%obuild_dir_project%\bin"\soqt-config.exe
IF EXIST "%obuild_dir_project%\bin"\HEPVisToStdIv.exe DEL "%obuild_dir_project%\bin"\HEPVisToStdIv.exe
FOR %%f IN ("%obuild_dir_project%\bin"\HEPVis_detector_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\HEPVis_*2pov) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\HEPVis_plotter_Plotter_*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\HEPVis_utils_TextTTF_*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\HEPVis_convert.exe DEL "%obuild_dir_project%\bin"\HEPVis_convert.exe
FOR %%f IN ("%obuild_dir_project%\bin"\HEPVis_*_SDL) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\HEPVis_config.exe DEL "%obuild_dir_project%\bin"\HEPVis_config.exe
IF EXIST "%obuild_dir_project%\bin"\HEPVis_config_save.exe DEL "%obuild_dir_project%\bin"\HEPVis_config_save.exe
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF EXIST osc_iv-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip DEL osc_iv-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip
IF EXIST osc_iv-darwin-app-16.11.8-%obuild_platform_signature%${obuild_debug_signature}.zip DEL osc_iv-darwin-app-16.11.8-%obuild_platform_signature%${obuild_debug_signature}.zip
zip -q -r osc_iv-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip osc_iv
cd "%obuild_osc_iv_path%\obuild"
cd "%obuild_osc_iv_path%\%obuild_dir_bin%"
IF EXIST obuild_platform.exe DEL obuild_platform.exe
cd "%obuild_pwd_osc_iv_0%"
SET obuild_pwd_osc_iv_0=
:obuild_return
ENDLOCAL
@ECHO ON
